$LARGE
*COPY ABC
      subroutine ABC
c
c     called by MES; interchanges axes for orthorhombic groups
c
      common long,nout,idm,inf,isc,ipol,r,ngr,iocfl,vol,nfl,volrat
      common /cel/ a,b,c,al,be,ga,alf,bet,gam,cosa,cosb,cosg
      common /matr/ifmat,ifsh,ifplus,xmat(3,3),plus(3),sh(3),nabc,nsh,
     1 nshtra,ifnig,xmsave(3,3),shif(3),minsh
      common /messa/ iw
      common /trans/s(9),u(9),t(9),p(9)
      character axes*6
      dimension pl(3)
c
      axes = 'a,b,c'
      axtol = 0.005
      iab = 0
      ibc = 0
*     minsh indicates which coordinate is going to be negative ->
*     change sign of eventual shift.
      minsh = 0
      ii = iw - 6
      do 30 i=1,9
   30 u(i) = 0.
      go to (1,2,2,1,2,2,1,1) ,ii
c
c     a < b < c
    1 if(abs(a-b).lt.axtol) then
        if(long.gt.0) then
          write(nout,24) a,b
          if(isc.eq.1) then
            write(*,24) a,b
          endif
        endif
        iab = 1
      endif
      if(abs(b-c).lt.axtol) then
        if(long.gt.0) then
          write(nout,25) b,c
          if(isc.eq.1) then
            write(*,25) b,c
          endif
        endif
        ibc = 1
      endif
      if(iab.eq.1.and.ibc.eq.1) return
      if(a.lt.b) then
        if(b.gt.c) then
          if(a.lt.c) then
          if(iw.eq.14) return
c     a-cb
      axes = 'a,-c,b'
          x = c
          c = b
          b = x
          u(1) = 1.
          u(6) =-1.
          u(8) = 1.
          minsh = 2
c     x-1/4 -z-1/4 y-1/4
          if(iw.eq.10) then
            pl(1) = .25
            pl(2) = .25
            pl(3) = .25
            nabc = 5
          endif
c     x-1/4 -z y-1/4
          if(iw.eq.13) then
            pl(1) = .25
            pl(3) = .25
            nabc = 12
          endif
          else
c     cab
      axes = 'c,a,b'
          x = c
          c = b
          b = a
          a = x
          u(3) = 1.
          u(4) = 1.
          u(8) = 1.
          endif
      endif
c
c     a > b
      else
        if(b.lt.c) then
          if(a.lt.c) then
          if(iw.eq.14) go to 10
c     ba-c
      axes = 'b,a,-c'
          x = b
          b = a
          a = x
          u(2) = 1.
          u(4) = 1.
          u(9) =-1.
          minsh = 3
c     y-1/4 x-1/4 3/4-z
          if(iw.eq.10) then
            pl(1) = .25
            pl(2) = .25
            pl(3) = .25
            nabc = 5
            endif
c     y-1/4 x-1/4 -z
          if(iw.eq.13) then
            pl(1) = .25
            pl(2) = .25
            nabc = 6
            endif
          else
c     bca
      axes = 'b,c,a'
            x = b
            b = c
            c = a
            a = x
          u(2) = 1.
          u(6) = 1.
          u(7) = 1.
            endif
          else
          if(iw.eq.14) go to 15
c     -cba
      axes = '-c,b,a'
            x = c
            c = a
            a = x
          u(3) =-1.
          u(5) = 1.
          u(7) = 1.
          minsh = 1
c     3/4-z y-1/4 x-1/4
          if(iw.eq.10) then
            pl(1) = .25
            pl(2) = .25
            pl(3) = .25
            nabc = 5
          endif
c     -z y-1/4 x-1/4
          if(iw.eq.13) then
            pl(2) = .25
            pl(3) = .25
            nabc = 15
            endif
          endif
        endif
      go to 20
 
c     bca  (for Pbca, iw=14)
 10   axes = 'b,c,a'
            x = b
            b = c
            c = a
            a = x
          u(2) = 1.
          u(6) = 1.
          u(7) = 1.
      go to 20
 
c     cab  (for Pbca, iw=14)
 15   axes = 'c,a,b'
          x = c
          c = b
          b = a
          a = x
          u(3) = 1.
          u(4) = 1.
          u(8) = 1.
      go to 20
 
c      a<b
    2 if(abs(a-b).lt.axtol) then
        if(long.eq.0) return
        write(nout,24) a,b
        if(isc.eq.1) then
          write(*,24) a,b
        endif
        return
      endif
      if(a.gt.b) then
c     ba-c
      axes = 'b,a,-c'
        x = b
        b = a
        a = x
      u(2) = 1.
      u(4) = 1.
      u(9) =-1.
      minsh = 3
c     y x 3/4-z
       if(iw.eq.9) then
         pl(3) = .25
         nabc = 16
      endif
       if(iw.eq.11) then
c     y-1/4 x-1/4 3/4-z
         pl(1) = .25
         pl(2) = .25
         pl(3) = .25
         nabc = 5
         endif
       if(iw.eq.12) then
c     y-1/4 x-1/4 -z
         pl(1) = .25
         pl(2) = .25
         nabc = 6
         endif
c
      endif
c
c-----update transformation matrix :
   20 if(axes.eq.'a,b,c') return
      do 32 i=1,3
      plus(i) = plus(i) + pl(i)
      if (plus(i).gt.1.) plus(i) = plus(i)-1.
   32 continue
      if(ifmat.eq.2) then
        call MATRIX(u,s,p)
        call RESET
      else
        do 31 i=1,9
   31   s(i) = u(i)
      endif
 
      ifmat = 2
      if(nabc.gt.0) ifplus = ifplus + 2
 
      if(long.eq.0) return
      write(nout,21) axes,a,b,c
      if(isc.eq.1) write(*,21) axes,a,b,c
   21 format(' Axes are changed to ',a6,5x,' new axes: ',3f9.4)
   24 format(/' WARNING : axes a & b are very similar:',2f10.4)
   25 format(/' WARNING : axes b & c are very similar:',2f10.4)
 
      return
      end
*COPY AXES
      subroutine AXES(s)
c     called by MAIN,SHORT and NIGGLI; writes charactervariable 'ax'
c
      common long,nout,idm,inf,isc,ipol,r,ngr,iocfl,vol,nfl,volrat
      common /lab/ax
      common /matr/ifmat,ifsh,ifplus,xmat(3,3),plus(3),sh(3),nabc,nsh,
     1 nshtra,ifnig,xmsave(3,3),shif(3),minsh
      character ax*47,c1*1,c2*1,cc(3)*1
      dimension iflag(9),s(9)
      data cc/'a','b','c'/
      ax = ' '
      ep = 0.00001
c-----look whether real coefficients in matrix s :
      do 1 i=1,9
      iflag(i) = 0
      sabs = abs(s(i))
      k = ifix(sabs+ep)
      ss = float(k)
      if(abs(float(k)-sabs).gt.0.0001) iflag(i) = 1
    1 continue
c-----look at axes :
      k = 0
      m = 1
      do 5 i=1,3
      mm = m
      do 6 j=1,3
      m1 = m
      k = k + 1
      kk = 0
      sk = abs(s(k))
      if(sk.gt.ep) then
        if(iflag(k).eq.0) kk = ifix(sk+ep)
        if(s(k).lt.0.)then
          ax(m:m) = '-'
          m = m + 1
        else if(m.gt.mm) then
          ax(m:m) = '+'
          m = m + 1
          endif
        if(iflag(k).eq.0) then
        if(kk.eq.1) m1 = m1-1
          if(kk.gt.1) then
            write(ax(m:m),'(i1)') kk
            m = m + 1
          endif
        else
          call CHARA(sk,c1,c2)
          ax(m:m) = c1
          ax(m+1:m+1) = '.'
          ax(m+2:m+2) = c2
          m = m + 3
        endif
        if(m.eq.m1.and.kk.eq.0) go to 6
        ax(m:m) = cc(j)
        m = m + 1
      endif
    6 continue
c
      if(i.lt.3) then
        ax(m:m) = ','
        m = m + 1
      endif
    5 continue
c
      return
      end
*COPY BEST
      subroutine BEST
cc    called by MESS; finds 'best' unit cell for monoclinic groups
c      see Parthe & Gelato, Acta Cryst (1985) A41,142-151.
c
      PARAMETER(nsiz=50)
      common long,nout,idm,inf,isc,ipol,r,ngr,iocfl,vol,nfl,volrat
      common /cel/ a,b,c,al,be,ga,alf,bet,gam,cosa,cosb,cosg
      common /lab/axs
      common /matr/ifmat,ifsh,ifplus,xmat(3,3),plus(3),sh(3),nabc,nsh,
     1 nshtra,ifnig,xmsave(3,3),shif(3),minsh
      common /messa/iw
      common /trans/s(9),u(9),t(9),p(9)
      character axs*47
      dimension v(nsiz,nsiz),vs(nsiz),ii(nsiz),jj(nsiz),pl(2)
c
c     remember if axes have already been transformed :
      iftra = 0
      if(ifmat.eq.2) iftra = 1
      do 7 i=1,9
    7 u(i) = 0.
      bb = be
      anew = a
      cnew = c
      l1 = 0
      l2 = 1
      sinb = sin(bet)
      do 20 i=1,nsiz
      do 20 j=1,nsiz
   20 v(j,i) = -0.5
      pl(1) = 0.
      pl(2) = 0.
      ip = 1
      iq = 0
      ir = 0
      is = 1
      if = 0
      isave = 0
      jsave = 0
      csa = cosb
      csc = cosb
      vmax = amax1(a,c)
      vlimit = vmax/sinb
      v2max=vmax**2
      imax = int(vlimit/a+1.)
      jmax = int(vlimit/c+1.)
      if(imax.ge.nsiz.or.jmax.ge.nsiz) then
        write(nout,9) imax,jmax
        write(*,9) imax,jmax
        return
        endif
    9 format(' WARNING : array size too small in routine for BEST'/
     1 ' cell needed are : ',2i4)
*     change value of nsiz in routine BEST
 
      do 1 i=1,imax
      ax = i*a
      ax2 = ax**2
      do 11 j=1,jmax
      cx = j*c
      v2 = ax2 + cx**2 + 2.*ax*cx*cosb
      if(v2.gt.v2max) go to 11
      if = 1
      vv = sqrt(v2)
      v(i+1,j+1) = vv
   11 continue
    1 continue
c
c-----a and c also in v : to all indices is added 1
      v(2,1) = a
      v(1,2) = c
c
c     sort vectors v:
      k = 0
   10 continue
      vmin = vmax
      ifk = 0
      k = k + 1
      imax = imax + 1
      jmax = jmax + 1
      if(k.gt.nsiz) go to 62
      do 15 j=1,jmax
      do 15 i=1,imax
      if(v(i,j).lt.0.) go to 15
      if(v(i,j).le.vmin) then
        vmin = v(i,j)
        ii(k) = i
        jj(k) = j
      ifk = 1
        endif
   15 continue
      if(ifk.eq.0) then
        k = k-1
      else
        vs(k) = vmin
        i = ii(k)
        j = jj(k)
        v(i,j) = -vmin
        go to 10
      endif
c
c     for IW = 2 we should take relabelled Niggli cell; take two
c     shortest vectors for a and c without parity restrictions :
      if(iw.eq.2) then
        if(vs(1).eq.vs(2)) then
          if(long.eq.2) write(nout,61)
          if(long.eq.2.and.isc.eq.1) write(*,61)
        endif
        ifa = 1
        ifc = 1
        anew = vs(1)
        cnew = vs(2)
        ip = ii(1) -1
        ir = ii(2) -1
        iq = jj(1) -1
        is = jj(2) -1
        go to 50
        endif
c
      igroup = iw - 2
      ifa = 0
      ifc = 0
      go to (51,52,53,53) ,igroup
c-----group 1 : C-groups ; q even, s odd
c-----group 2 : P-groups ; p odd, r even
   52 l1 = 1
      l2 = 0
   51 continue
      k1 = 1
   21 do 31 i=k1,k
      i1 = ii(i) - 1
      j1 = jj(i) - 1
      kk = i1
      if(igroup.eq.1) kk=j1
      if(mod(kk,2).eq.l1) then
        if(ifc.eq.0.or.abs(i1*is-j1*ir).eq.1) then
           ip = i1
           iq = j1
           ifa = i
           anew = vs(i)
           endif
      else
        if(ifa.eq.0.or.abs(i1*iq-j1*ip).eq.1) then
           is = j1
           ir = i1
           cnew = vs(i)
           ifc = i
           endif
       endif
        if(ifa.gt.0.and.ifc.gt.0) go to 50
        if(ifa.gt.0.or.ifc.gt.0) go to 80
   31 continue
   80 if(ifa.gt.0) then
c     look for c: r even for P-group; s odd for C-group
       do 81 j=1,k
       if(j.eq.ifa) go to 81
      i1 = ii(j) - 1
      j1 = jj(j) - 1
      kk = i1
      if(igroup.eq.1) kk=j1
      if(mod(kk,2).eq.l2) then
        if(abs(i1*iq-j1*ip).eq.1) then
           is = j1
           ir = i1
           cnew = vs(j)
           ifc = j
      go to 50
           endif
      endif
   81 continue
      if(k1.eq.k) go to 60
      ifa = 0
      ifc = 0
      k1 = k1 + 1
      go to 21
      else
c     look for a (p odd for P-group; q even for C-group)
      do 82 j=1,k
      if(j.eq.ifc) go to 82
      i1 = ii(j) - 1
      j1 = jj(j) - 1
      kk = i1
      if(igroup.eq.1) kk=j1
      if(mod(kk,2).eq.l1) then
        if(abs(i1*is-j1*ir).eq.1) then
           ip = i1
           iq = j1
           ifa = j
           anew = vs(j)
      go to 50
           endif
      endif
   82 continue
      if(k1.eq.k) go to 60
      ifa = 0
      ifc = 0
      k1 = k1 + 1
      go to 21
      endif
c
c-----C c  and C 2/c  ; p odd, q even, s odd
   53 k1 = 1
   23 do 33 i=k1,k
      i1 = ii(i) - 1
      j1 = jj(i) - 1
      if(mod(j1,2).eq.0) then
c     may be new a
        if(mod(i1,2).eq.1) then
        if(ifc.eq.0.or.abs(i1*is-j1*ir).eq.1) then
           ip = i1
           iq = j1
           ifa = i
           anew = vs(i)
           endif
      endif
      else
        if(ifa.eq.0.or.abs(i1*iq-j1*ip).eq.1) then
           is = j1
           ir = i1
           cnew = vs(i)
           ifc = i
           endif
       endif
        if(ifa.gt.0.and.ifc.gt.0) go to 55
        if(ifa.gt.0.or.ifc.gt.0) go to 86
   33 continue
   86 if(ifa.gt.0) then
c     look for c : s odd
       do 87 j=1,k
       if(j.eq.ifa) go to 87
      i1 = ii(j) - 1
      j1 = jj(j) - 1
      if(mod(j1,2).eq.1) then
        if(abs(i1*iq-j1*ip).eq.1) then
           is = j1
           ir = i1
           cnew = vs(j)
           ifc = j
      go to 55
           endif
      endif
   87 continue
      if(k1.eq.k) go to 60
      ifa = 0
      ifc = 0
      k1 = k1 + 1
      go to 23
      else
c     look for a : p odd , q even
      do 88 j=1,k
       if(j.eq.ifc) go to 88
      i1 = ii(j) - 1
      j1 = jj(j) - 1
      if(mod(i1,2).eq.1.and.mod(j1,2).eq.0) then
        if(abs(i1*is-j1*ir).eq.1) then
           ip = i1
           iq = j1
           ifa = j
           anew = vs(j)
      go to 55
           endif
      endif
   88 continue
      if(k1.eq.k) go to 60
      ifa = 0
      ifc = 0
      k1 = k1 + 1
      go to 23
      endif
c
   55   if(mod(ir,2).eq.1) then
        if(igroup.eq.3) then
          pl(2) = .25
          plus(2) = plus(2) + .25
          nsh = 17
        else
          pl(1) = .25
          pl(2) = .25
          plus(1) = plus(1) + .25
          plus(2) = plus(2) + .25
          nsh = 6
        endif
      ifplus = ifplus + 4
      endif
c
c
   50 if(ip.eq.1.and.iq.eq.0.and.ir.eq.0.and.ip.eq.1) return
      ifmat = 2
      if(ip.eq.0.or.iq.eq.0) ifa = 0
      if(ir.eq.0.or.is.eq.0) ifc = 0
      u(5) = 1.
      if = 1
        u(1) = float(ip)
        u(3) = float(iq)
        csc = 1.
        if(iq.ne.0)csc =(anew**2+(iq*c)**2-(ip*a)**2)/(2.*anew*iq*c)
        u(7) = float(ir)
        u(9) = float(is)
        csa = 1.
        if(ir.ne.0)csa =(cnew**2+(ir*a)**2-(is*c)**2)/(2.*cnew*ir*a)
c
c
c     compute new angle beta :
c     (we cannot use the simple formula based on constant volume :
c     a'c'sin(beta') = acsin(beta) because this does not tell us the
c     sign of the new axes ).
      neg = 1
      if(ifa.gt.0.and.ifc.gt.0) then
      b1 = r*acos(csa)
      b2 = r*acos(csc)
      bb = be-b1-b2
      if(bb.lt.0.) then
        bb = 180. + bb
        neg = -1
        endif
      if (bb.lt.90.) then
        bb = 180. - bb
        neg = -neg
      endif
      else if(ifa.gt.0) then
      if(ir.eq.0) then
       cs = csc
      else
       cs =((ip*a)**2+anew**2-(iq*c)**2)/(2.*ip*a*anew)
      endif
        if(cs.gt.0.) neg = -1
          bb = r*acos(neg*cs)
      else if(ifc.gt.0) then
      if(iq.eq.0) then
       cs = csa
      else
       cs =((is*c)**2+cnew**2-(ir*a)**2)/(2.*is*c*cnew)
      endif
        if(cs.gt.0.) neg = -1
        cosb = neg*cs
        bb = r*acos(neg*cs)
      endif
c
      if(long.eq.2) then
        write(nout,30) ip,a,iq,c,anew
        write(nout,34) ir,a,is,c,cnew
        write(nout,35) bb
        if(isc.eq.1) then
          write(*,30) ip,a,iq,c,anew
          write(*,34) ir,a,is,c,cnew
          write(*,35) bb
        endif
      endif
   30 format(/' new a = ',i2,' *',f8.4,' +',i2,' *',f8.4,' = ',f8.4)
   34 format(' new c = ',i2,' *',f8.4,' +',i2,' *',f8.4,' = ',f8.4)
   35 format(' New angle beta = ',f8.4)
      u(1) = neg*u(1)
      u(3) = neg*u(3)
      det = u(1)*u(9)-u(3)*u(7)
      if(det.lt.0.) u(5) = -u(5)
      call AXES(u)
      if(long.gt.0) then
        if(isc.eq.1)write(*,100) axs
        write(nout,100) axs
      endif
  100 format(' Transformation of axes due to cell reduction : ',a47)
      call MATRIX(u,s,p)
      call RESET
      a = anew
      c = cnew
      be = bb
      if(iftra.eq.1) then
        call AXES(s)
        if(long.gt.0) then
          if(isc.eq.1)write(*,101) axs
          write(nout,101) axs
        endif
      endif
  101 format(' Total transformation of axes : ',a)
      if(long.eq.0) return
      if(isc.eq.1) write(*,36) a,b,c,al,be,ga
      write(nout,36) a,b,c,al,be,ga
   36 format(/' Cell parameters after reduction :'/ ,6f9.4)
      return
 
   60 if(long.eq.2.and.isc.eq.1) write(*,61)
      if(long.eq.2) write(nout,61)
   61 format(' No cell reduction found ')
      return
   62 write(nout,63)
      write(*,63)
   63 format(' WARNING : cell has not been reduced due to too small',
     1' array size.')
*     Change parameter NSIZ in subroutine SHORT
      return
c
      end
*COPY CELRDN
      subroutine CELRDN(ifmat)
c-----called by MAIN and MES (subroutine of STIDY)
c     calls routines for Niggli-reduced cell.
c
      common long,nout,idm,inf,isc,ipol,r,ngr,iocfl,vol,nfl,volrat
      common /brz/ngo,ir(48,3,3),it(48,3),nbr
      common /cel/a,b,c,al,be,ga,alf,bet,gam,cosa,cosb,cosg
      COMMON/DOTS/SF11,SF22,SF33,SF23,SF13,SF12,ITYPE,DOTAB,DOTAC,DOTBC
      common /garb/ierr,igo,ired,e1,ithru
      common /trans/uvw(9),u(9),t(9),p(9)
c
      e1 = 0.000001
 
      ierr = 0
c----- transformation to primitive cell
      call SETM(nbr)
c----- transform cell by (u1 v1 w1/u2 v2 w2/u3 v3 w3) :
      call DOTA
      call REDUC
c
c     Write final matrix:
      if(long.eq.2) write(nout,11) uvw
      if(long.eq.2.and.isc.eq.1)write(*,11) uvw
   11 format(//' Transformation matrix for Niggli cell : '/(' ',3f4.1))
c-----Is uvw the unit-matrix ?
      if(uvw(1).eq.1..and.uvw(2).eq.0..and.uvw(3).eq.0..and.uvw(4).eq.0.
     1 .and.uvw(5).eq.1..and.uvw(6).eq.0..and.uvw(7).eq.0..and.
     2 uvw(8).eq.0..and.uvw(9).eq.1.) go to 50
c
      ifmat = 2
      a = sqrt(sf11)
      b = sqrt(sf22)
      c = sqrt(sf33)
      cosa = sf23/(b*c)
      cosb = sf13/(a*c)
      cosg = sf12/(a*b)
      alf = acos(cosa)
      bet = acos(cosb)
      gam = acos(cosg)
      al = alf*r
      be = bet*r
      ga = gam*r
      if(long.gt.0) then
        if(isc.eq.1)write(*,12) a,b,c,al,be,ga
        write(nout,12) a,b,c,al,be,ga
      endif
   12 format(//' Cell parameters after reduction :'/ ,6f10.4)
      call AXES(uvw)
      return
 
c     if axes not changed, keep inputvalues:
   50 if(long.gt.0) then
        if(isc.eq.1.and.long.gt.1)write(*,51) a,b,c,al,be,ga
        if(long.gt.1) write(nout,51) a,b,c,al,be,ga
      endif
   51 format(' No cell reduction; keep original cell parameters :'/
     1 ' ',6f10.4)
      ifmat = 0
      return
      end
*COPY CHARA
      subroutine CHARA(s,c1,c2)
c-----called by AXES (subroutine of STIDY)
c     writes floating point variable into character variables
c     ( s is always positive)
c
      character*1 c1,c2
      c1 = ' '
      c2 = ' '
      ii = ifix(s+0.00001)
      write(c1,'(i1)') ii
      i1 = ifix((s+.05-float(ii))*10)
      write(c2,'(i1)') i1
      return
      end
*COPY DOTA
      SUBROUTINE DOTA
C
C
c     This routine was adapted from NBS*AIDS80 (Mighell, Hubbard & Stali
c
C     TRANSFORMS THE INITIAL CELL
C     ******************************************************************
C
      common long,nout,idm,inf,isc,ipol,r,ngr,iocfl,vol,nfl,volrat
      common /cel/a,b,c,al,be,ga,alf,bet,gam,cosa,cosb,cosg
      COMMON/TRANS/ U1,V1,W1,U2,V2,W2,U3,V3,W3,U(9),T(9),P(9)
      COMMON/DOTS/SF11,SF22,SF33,SF23,SF13,SF12,ITYPE,DOTAB,DOTAC,DOTBC
      DIMENSION DOT(6),axf(6),ux1(3),ux2(3),ux(9)
C
      UX(1)=U1
      UX(2)=V1
      UX(3)=W1
      UX(4)=U2
      UX(5)=V2
      UX(6)=W2
      UX(7)=U3
      UX(8)=V3
      UX(9)=W3
      N=0
      I=0
C
C
C     CALCULATE THE 6 DOT PRODUCTS (DOT(1)...DOT(6))
      DO 40 N=1,6
      DO 30 II=1,3
      NN=II
      MM=II
      IF (N.EQ.2) MM=II+3
      IF (N.EQ.2) NN=II+3
      IF (N.EQ.3) MM=II+6
      IF (N.EQ.3) NN=II+6
      IF (N.EQ.4) NN=II+3
      IF (N.EQ.5) NN=II+6
      IF (N.EQ.6) MM=II+3
      IF (N.EQ.6) NN=II+6
      UX1(II)=UX(MM)
      UX2(II)=UX(NN)
30    CONTINUE
      C1=UX1(1)*UX2(1)
      C2=UX1(2)*UX2(2)
      C3=UX1(3)*UX2(3)
      C4=UX1(3)*UX2(2)+UX1(2)*UX2(3)
      C5=UX1(3)*UX2(1)+UX1(1)*UX2(3)
      C6=UX1(1)*UX2(2)+UX1(2)*UX2(1)
C
C----CALCULATE DOT PRODUCTS AND PARTIALS OF THE DOT PRODUCTS WITH
C     RESPECT TO A, B, C, alf, bet, GAM (IN RADIANS)
      DOT(N)=C1*(A**2)+C2*(B**2)+C3*(C**2)+C4*C*B*COS(Alf)+C5*C*A*
     2COS(bet)+C6*A*B*COS(gam)
40    CONTINUE
      AXF(1)=SQRT(DOT(1))
      AXF(2)=SQRT(DOT(2))
      AXF(3)=SQRT(DOT(3))
      COSA=DOT(6)/(AXF(2)*AXF(3))
      COSB=DOT(5)/(AXF(1)*AXF(3))
      COSG=DOT(4)/(AXF(1)*AXF(2))
      AXF(4)=ACOS(COSA)*R
      AXF(5)=ACOS(COSB)*R
      AXF(6)=ACOS(COSG)*R
      A=AXF(1)
      B =AXF(2)
      C =AXF(3)
      alf=AXF(4)/R
      bet=AXF(5)/R
      gam=AXF(6)/R
      SINA=SIN(alf)
      SINB=SIN(bet)
      SING=SIN(gam)
      al   =AXF(4)
      be   =AXF(5)
      ga   =AXF(6)
      DOTAB=DOT(4)
      DOTAC=DOT(5)
      DOTBC=DOT(6)
      return
      end
*COPY INVERT
      subroutine INVERT(*)
c      called by main of STIDY
c     inverts 3x3 matrix  s -> t
c     S transforms the row matrix (a,b,c)
c     T is the inverted matrix with rows and columns interchanged;
c     so t transforms the ROW matrix (x,y,z).
 
      common long,nout,idm,inf,isc,ipol,r,ngr,iocfl,vol,nfl,volrat
      common /matr/ifmat,ifsh,ifplus,tt(3,3),plus(3),sh(3),nabc,nsh,
     1 nshtra,ifnig,xmsave(3,3),shif(3),minsh
      common /trans/s(3,3),u(9),t(9),p(9)
 
c      compute determinant d :
      d = s(1,1) * (s(2,2)*s(3,3)-s(2,3)*s(3,2)) -
     1    s(1,2) * (s(2,1)*s(3,3)-s(3,1)*s(2,3)) +
     2    s(1,3) * (s(2,1)*s(3,2)-s(3,1)*s(2,2))
      if(abs(d).lt.0.00001) then
         return 1
      endif
 
      do 1 j=1,3
      do 1 i=1,3
      i1 = i + 1
      if(i1.gt.3) i1 = i1 - 3
      i2 = i + 2
      if(i2.gt.3) i2 = i2 - 3
      j1 = j + 1
      j2 = j + 2
      if(j1.gt.3) j1 = j1 - 3
      if(j2.gt.3) j2 = j2 - 3
      tt(i,j) = (s(i1,j1)*s(i2,j2)-s(i2,j1)*s(i1,j2)) / d
    1 continue
 
      return
      end
*COPY MESS
      subroutine MESS
*      called by main for STIDY
      common long,nout,idm,inf,isc,ipol,r,ngr,iocfl,vol,nfl,volrat
      common /cel/ a,b,c,al,be,ga,alf,bet,gam,cosa,cosb,cosg
      common /matr/ifmat,ifsh,ifplus,xmat(3,3),plus(3),sh(3),nabc,nsh,
     1 nshtra,ifnig,xmsave(3,3),shif(3),minsh
      common /messa/ iw
      character ansr*1
 
      ifbest = 0
      root = 1.
      csb = -cosb
      csb = -cosb
      cs = 1./2.*csb
      css = csb
      ca = c/a
      if(iw.lt.0) then
       if(long.gt.0) write(nout,43)
       iw = -iw
   50   if(idm.eq.1) write(*,21)
        read(inf,22) ansr
        if(ansr.eq.'?') then
          write(*,800)
  800 format(' Origin shift for non-centrosymmetric settings.'/
     1' The origin should be at the centre of symmetry.'/)
          go to 50
        endif
        if(inf.eq.5) write(11,115) ansr
        if(ansr.eq.'Y'.or.ansr.eq.'y') ifsh = 1
      endif
      go to (1,2,3,4,3,3,7,8,9,10,11,12,13,14,15,16),iw
    1 if(long.gt.0) write(nout,31)
      nig = 0
      call CELRDN(ifmat)
      return
c     P2  P21  Pm  P2/m  P21/m
    2 if(long.gt.0) write(nout,32)
      if(a.gt.c) go to 100
      root = 1.
      cs = 1./(2.*csb)
      if(ca.ge.1..and.ca.ge.cs) go to 100
      css= 2.*csb
      if(ca.le.1..and.ca.le.css) go to 100
      if(long.gt.0) then
        if(isc.eq.1)write(*,46)
        write(nout,46)
      endif
      if(abs(a-c).lt.0.001*a.and.long.gt.0) then
        write(nout,45)
        write(*,45)
      endif
   45 format(/' WARNING : a & c are very similar.'/)
   46 format(/' No cell reduction possible.')
      go to 200
c     C2  Cm  C2/m  Cc  C2/c
    3 root = 1./sqrt(2.)
      cs = 1./(2.*csb)
      css = csb
      if(ca.ge.root.and.ca.ge.cs) go to 5
      if(ca.le.root.and.ca.le.css) go to 5
      if(long.gt.0) write(nout,46)
      go to 200
c     Pc  P2/c  P21/c
    4 root = sqrt(2.)
      cs = 1./csb
      if(ca.ge.root.and.ca.ge.cs) go to 5
      css= 2.*csb
      if(ca.le.root.and.ca.le.css) go to 5
      if(long.gt.0) write(nout,46)
      go to 200
    5 if(long.gt.0) write(nout,33)
 100  call BEST
      ifbest = 1
*     ricompute parameters:
      ca = c/a
      csb = -cos(be*3.14159265/180.)
      if(iw.eq.2) then
        root = 1.
        cs = 1./(2.*csb)
        css = 2.*csb
      else if(iw.eq.3.or.iw.eq.5.or.iw.eq.6) then
        root = 1./sqrt(2.)
        cs = 1./(2.*csb)
        css = csb
      else if(iw.eq.4) then
        root = sqrt(2.)
        cs = 1./csb
        css = 2.*csb
      endif
 
      go to 200
 
    7 if(long.gt.0) write(nout,35)
      go to 101
    8 if(long.gt.0) write(nout,36)
      go to 101
    9 if(long.gt.0) write(nout,37)
      go to 101
   10 if(long.gt.0) write(nout,38)
      go to 101
   11 if(long.gt.0) write(nout,39)
      go to 101
   12 if(long.gt.0) write(nout,40)
      go to 101
   13 if(long.gt.0) write(nout,41)
      go to 101
   14 if(long.gt.0) write(nout,42)
      go to 101
   15 if(long.gt.0) write(nout,43)
   60 if(idm.eq.1) write(*,21)
   21  format(' Origin to be shifted? (Y/N)')
      read(inf,22)ansr
   22 format(a1)
      if(ansr.eq.'?') then
          write(*,800)
        go to 60
        endif
      if(ansr.eq.'Y'.or.ansr.eq.'y') ifsh = 1
      if(inf.eq.5) write(11,22) ansr
   16 return
 
  101 call ABC
      return
 
*     if test for best cell gives values within 1%, give warning:
  200 rt1 = root-0.01*root
      rt2 = root+0.01*root
      cs1  = cs -0.01*cs
      css2 = css+0.01*css
      if(long.eq.0) return
      if(ca.ge.rt1.and.ca.ge.cs1) then
        if(ifbest.eq.0) then
          write(nout,210)
          write(*,210)
        else
          write(nout,220)
          write(*,220)
        endif
      else if(ca.le.rt2.and.ca.le.css2) then
        if(ifbest.eq.0) then
          write(nout,210)
          write(*,210)
        else
          write(nout,220)
          write(*,220)
        endif
      endif
*     test on c/a only for groups P2, P21, Pm, P2/m, P21/m:
      if(ca.ge..97.and.ca.le.1.03.and.iw.eq.2) then
        write(nout,230)
        write(*,230)
      endif
      if(be.le.90.3) then
        write(nout,240)
        write(*,240)
      endif
 
      return
  210 format('-------------------------------------------------------'/
     1' WARNING : slightly different cell parameters may give'/
     2' a different BEST cell.'/
     3'-------------------------------------------------------' )
  220 format('-------------------------------------------------------'/
     1' WARNING : the found "best" cell is very near a border line.'/
     2' A slight difference in c/a or beta may give a different'/
     3' BEST cell.'/
     4'-------------------------------------------------------')
  230 format('-------------------------------------------------------'/
     1' WARNING : c/a value near to 1. Slightly different cell'/
     2' parameters may give a different BEST cell.'/
     3'-------------------------------------------------------')
  240 format('-------------------------------------------------------'/
     1' WARNING : beta near to 90 deg. A slight difference'/
     2' in beta may give a different BEST cell.'/
     3'-------------------------------------------------------')
 
  115 format(a1)
   31 format(' Take Niggli reduced cell with  a < b < c.')
   32 format(' Take Reset Niggli reduced cell with  a < c.')
   33 format(' a & c should be shortest translation vectors possible.')
   35 format('  a < b < c'/)
   36 format('  a < b'/)
   37 format('  a < b , for ba-c origin shift of 0 0 1/4 after',
     1' permutation'/)
   38 format('  a < b < c, for ba-c , a-cb , -cba'/' origin shift of',
     1'  1/4 1/4 1/4  after permutation of axes'/)
   39 format('  a < b , for ba-c  origin shift of 1/4 1/4 1/4'/)
   40 format('  a < b , for ba-c  origin shift of 1/4 1/4 0'/)
   41 format('  a < b < c , for ba-c , a-cb , -cba'/'  origin shift of re
     1sp.  1/4 1/4 0 , 1/4 0 1/4 , 0 1/4 1/4 after permutation'/)
   42 format('  a < b < c   only if possible by cyclic permutation; ',
     1 'otherwise  a < b'/)
   43 format(' Take settting with origin in centre of symmetry')
      end
*COPY NIGGLI
      SUBROUTINE NIGGLI
C
c     This routine was adapted from NBS*AIDS80 (Mighell, Hubbard & Stali
c     Called from REDUC
c
C        **********CHECK TO SEE IF THE CELL IS REDUCED**********
C
      common long,nout,idm,inf,isc,ipol,r,ngr,iocfl,vol,nfl,volrat
      COMMON/DOTS/SF11,SF22,SF33,SF23,SF13,SF12,ITYPE,DOTAB,DOTAC,DOTBC
      COMMON/GARB/ ierr, igo, ired ,e1,ithru
C
C
      IGO=0
      IRED=0
      IMAIN1=0
C
C
      ER=0.000001
      Q=0.0005
      QQ=0.0005
      IF (ITHRU.EQ.1.AND.ITYPE.EQ.1) GO TO 15
      IF (ITHRU.EQ.1.AND.ITYPE.EQ.2) GO TO 95
C
C        **********CHECK NIGGLIS MAIN CONDITIONS FOR REDUCTION**********
C      THE THREE SHORTEST LATTICE TRANSLATIONS
C
      Q1=2.0*ABS(SF23)
      Q2=2.0*ABS(SF13)
      Q3=2.0*ABS(SF12)
      X11=SF11+ER
      X22=SF22+ER
      X33=SF33+ER
      IF (X11.LE.X22.AND.X22.LE.X33.AND.Q1.LE.X22.AND.Q2.LE.X11.AND.Q3.L
     1E.X11) IMAIN1=1
C
C
      IF (ITYPE.EQ.1) GO TO 5
C
C     TYPE2 CELL SO CHECK THE SECOND PART OF THE MAIN CONDITIONS
C
      TEMP1=SF11+SF22+ER
      TEMP2=2.0*(ABS(SF23)+ABS(SF13)+ABS(SF12))
      IF (TEMP1.LT.TEMP2) IMAIN1=0
5     ITHRU=1
      E1=0.00001
      IF(IMAIN1.NE.0) GOTO 190
       WRITE(nout,10)
       WRITE(*,10)
10    FORMAT(1H ,45H**ERROR**FAILED MAIN CONDITIONS FOR REDUCTION)
      IERR=IERR+1
      GO TO 190
C
C    ********TEST FOR SPECIAL CONDITIONS FOR TYPE 1 CELL(+++)********
C
15    TS1=ABS(SF11-SF22)
      TS2=ABS(SF22-SF33)
      TS3=ABS((2.0*SF23)-SF22)
      TS4=ABS((2.0*SF13)-SF11)
      TS5=ABS((2.0*SF12)-SF11)
C
C
      IF ((TS1/SF11).GT.QQ) GO TO 30
       IF(long.eq.2)WRITE(nout,20) SF11,SF22,SF33,SF23,SF13,SF12
20    FORMAT(2X,12HNIGGLI +++ A,2X,6F15.6)
      IF((SF13+ER).GE.SF23) GO TO 30
C    FAILED SPECIAL CONDITION ONE (+++)
25    IGO=1
      GO TO 190
30    IF ((TS2/SF22).GT.QQ) GO TO 45
       IF(long.eq.2)WRITE(nout,35) SF11,SF22,SF33,SF23,SF13,SF12
35    FORMAT(2X,12HNIGGLI +++ B,2X,6F15.6)
      IF((SF12+ER).GE.SF13)GO TO 45
C     FAILED SPECIAL CONDITION TWO(+++)
40    IGO=2
      GO TO 190
45    IF ((TS3/SF22).GT.Q) GO TO 60
       IF(long.eq.2)WRITE(nout,50) SF11,SF22,SF33,SF23,SF13,SF12
50    FORMAT(2X,12HNIGGLI +++ C,2X,6F15.6)
      IF((2.0*SF13+ER).GE.SF12) GO TO 60
C     FAILED SPECIAL CONDITION THREE(+++)
55    IGO=3
      GO TO 190
60    IF ((TS4/SF11).GT.Q) GO TO 75
       IF(long.eq.2)WRITE(nout,65) SF11,SF22,SF33,SF23,SF13,SF12
65    FORMAT(2X,12HNIGGLI +++ D,2X,6F15.6)
      IF((2.0*SF23+ER).GE.SF12) GO TO 75
C     FAILED SPECIAL CONDITION FOUR(+++)
70    IGO=4
      GO TO 190
75    IF ((TS5/SF11).GT.Q) GO TO 90
       IF(long.eq.2)WRITE(nout,80) SF11,SF22,SF33,SF23,SF13,SF12
80    FORMAT(2X,12HNIGGLI +++ E,2X,6F15.6)
      IF((2.0*SF23+ER).GE.SF13) GO TO 90
C     FAILED SPECIAL CONDITION FIVE(+++)
85    IGO=5
      GO TO 190
90    IRED=1
C
C     CELL REDUCED IF IRED=1
C
      GO TO 190
C
C    *********TEST FOR SPECIAL CONDITIONS FOR TYPE 2 CELL(---)**********
C
C
95    TS1=ABS(SF11-SF22)
       TS2=ABS(SF22-SF33)
      TS3=ABS(ABS(2.0*SF23)-SF22)
      TS4=ABS(ABS(2.0*SF13)-SF11)
      TS5=ABS(ABS(2.0*SF12)-SF11)
      TEM1=SF11+SF22
      TEM2=2.0*(ABS(SF23)+ABS(SF13)+ABS(SF12))
      TS6=ABS(TEM1-TEM2)
      IF ((TS1/SF11).GT.QQ) GO TO 110
       IF(long.eq.2)WRITE(nout,100)SF11,SF22,SF33,SF23,SF13,SF12
100   FORMAT(2X,12HNIGGLI --- A,2X,6F15.6)
      IF((ABS(SF13)+ER).GE.ABS(SF23))GO TO 110
C     FAILED SPECIAL CONDITION ONE(---)
105   IGO=1
      GO TO 190
110   IF ((TS2/SF22).GT.QQ) GO TO 125
       IF(long.eq.2)WRITE(nout,115)SF11,SF22,SF33,SF23,SF13,SF12
115   FORMAT(2X,12HNIGGLI --- B,2X,6F15.6)
      IF((ABS(SF12)+ER).GE.ABS(SF13)) GO TO 125
C     FAILED SPECIAL CONDITION TWO(---)
120   IGO=2
      GO TO 190
125   IF ((TS3/SF22).GT.Q) GO TO 140
       IF(long.eq.2)WRITE(nout,130)SF11,SF22,SF33,SF23,SF13,SF12
130   FORMAT(2X,12HNIGGLI --- C,2X,6F15.6)
      IF(Q.GE.ABS(SF12)) GO TO 140
C     FAILED SPECIAL CONDITION THREE(---)
135   IGO=6
      GO TO 190
140   IF ((TS4/SF11).GT.Q) GO TO 155
       IF(long.eq.2)WRITE(nout,145)SF11,SF22,SF33,SF23,SF13,SF12
145   FORMAT(2X,12HNIGGLI --- D,2X,6F15.6)
      IF(Q.GE.ABS(SF12)) GO TO 155
150   IGO=7
      GO TO 190
155   IF ((TS5/SF11).GT.Q) GO TO 170
       IF(long.eq.2)WRITE(nout,160)SF11,SF22,SF33,SF23,SF13,SF12
160   FORMAT(2X,12HNIGGLI --- E,2X,6F15.6)
      IF(Q.GE.ABS(SF13)) GO TO 170
C     FAILED SPECIAL CONDITION FIVE(---)
165   IGO=8
      GO TO 190
170   IF ((TS6/(SF11+SF22)).GT.Q) GO TO 185
       IF(long.eq.2)WRITE(nout,175)SF11,SF22,SF33,SF23,SF13,SF12
175   FORMAT(2X,12HNIGGLI --- F,2X,6F15.6)
      X1=ABS(SF13)
      X2=ABS(SF12)
      X3=2.0*X1+X2
C
      IF((X3+ER).GE.SF11) GO TO 185
C     FAILED SPECIAL CONDITION SIX(---)
180   IGO=9
      GO TO 190
185   IRED=1
C
C     CELL REDUCED IF IRED=1
C
190   RETURN
      END
*COPY NORM
      SUBROUTINE NORM
C
c     This routine was adapted from NBS*AIDS80 (Mighell, Hubbard & Stali
c
C        **********PUT THE CELL IN NORMAL REPRESENTATION**********
C
      common long,nout,idm,inf,isc,ipol,r,ngr,iocfl,vol,nfl,volrat
      COMMON/DOTS/SF11,SF22,SF33,SF23,SF13,SF12,ITYPE,DOTAB,DOTAC,DOTBC
      COMMON/GARB/ ierr, igo, ired ,e1,ithru
      COMMON/TRANS/ uvw(9),U(9),T(9),P(9)
C
C
C     THE CELL IS SET AS A TYPE 1 OR TYPE 2 CELL-
C     TYPE 1 CELL (+++) ALL ANGLES LESS THAN 90 DEGREES,
C
C     TYPE 2 CELL (---) ALL ANGLES = OR GREATER THAN 90 DEGREES.
C
C     IF NECESSARY, THIS SUBROUTINE CHANGES THE SIGNS ON THE UNSYMMETRIC
C     SCALARS (SF23,SF13,SF12) SO THAT THEY ARE ALL POSITIVE, ALL
C     NEGATIVE, OR ZERO AND NEGATIVE.  ALSO THE TOTAL TRANSFORMATION
C     MATRIX IS UPDATED.
C
      ITYPE=0
C
      CALL SET
C
C
      Z=0
C
      COSA=SF23/(SQRT(SF22)*SQRT(SF33))
      ACOSA=ABS(COSA)
      COSB=SF13/(SQRT(SF11)*SQRT(SF33))
      ACOSB=ABS(COSB)
      COSG=SF12/(SQRT(SF11)*SQRT(SF22))
      ACOSG=ABS(COSG)
      IF (ACOSA.LE.E1.OR.ACOSB.LE.E1.OR.ACOSG.LE.E1) GO TO 5
      GO TO 40
5     CONTINUE
C
C        *****ONE OR MORE ANGLES 90 DEGREES- TYPE 2 CELL*****
C
C
C     IF COMBINATIONS OF 0 AND - (0--,-0-,--0,00-,0-0,-00,000,---)
C     THE CELL IS IN NORMAL REPRESENTATION AND NOR FURTHER TRANSFORMATIO
C     IS REQUIRED.
      IF (COSA.LE.E1.AND.COSB.LE.E1.AND.COSG.LE.E1) ITYPE=2
      IF (COSA.LE.E1.AND.COSB.LE.E1.AND.COSG.LE.E1) GO TO 105
C
C                  0++       0--
C     CONVERT      0+0  TO   0-0     BY REVERSING VECTORS B AND C
C                  -+0       --0
C                  -0+       -0-
                  IF(ACOSA.LE.E1.AND. COSB.GT.E1.AND. COSG.GT.E1.OR.
     2               ACOSA.LE.E1.AND. COSB.GT.E1.AND.ACOSG.LE.E1.OR.
     3ACOSA.GT.E1.AND.COSA.LT.Z .AND. COSB.GT.E1.AND.ACOSG.LE.E1.OR.
     4ACOSA.GT.E1.AND.COSA.LT.Z .AND.ACOSB.LE.E1.AND.COSG .GT.E1)GOTO10
      GO TO 15
10    U(1)=1.0
      U(5)=-1.0
      U(9)=-1.0
      GO TO 35
15    CONTINUE
C
C                  +0+       -0-
C     CONVERT      00+  TO   00-     BY REVERSING VECTORS A AND C
C                  +-0       --0
C                  0-+       0--
      IF(COSA.GT.E1.AND.ACOSB.LE.E1.              AND.COSG .GT.E1.OR.
     2  ACOSA.LE.E1.AND.ACOSB.LE.E1.              AND.COSG .GT.E1.OR.
     3   COSA.GT.E1.AND.ACOSB.GT.E1.AND.COSB.LT.Z.AND.ACOSG.LE.E1.OR.
     4  ACOSA.LE.E1.AND.ACOSB.GT.E1.AND.COSB.LT.Z.AND.COSG .GT.E1)GOTO20
      GO TO 25
20    CONTINUE
      U(1)=-1.0
      U(5)=1.0
      U(9)=-1.0
      GO TO 35
25    CONTINUE
C
C                  ++0       --0
C     CONVERT      +00  TO   -00     BY REVERSING VECTORS A AND B
C                  +0-       -0-
C                  0+-       0--
      IF(COSA.GT.E1.AND.COSB .GT.E1.AND.ACOSG.LE.E1.OR.
     2   COSA.GT.E1.AND.ACOSB.LE.E1.AND.ACOSG.LE.E1.OR.
     3   COSA.GT.E1.AND.ACOSB.LE.E1.AND.ACOSG.GT.E1.AND.COSG.LT.Z.OR.
     4  ACOSA.LE.E1.AND.COSB .GT.E1.AND.ACOSG.GT.E1.AND.COSG.LT.Z)GOTO30
C     ERROR
C
      GO TO 105
30    U(1)=-1.0
      U(5)=-1.0
      U(9)=1.0
35    SF23=-ABS(SF23)
      SF13=-ABS(SF13)
      SF12=-ABS(SF12)
      CALL MATRIX (U,T,P)
      ITYPE=2
      GO TO 100
C
C        *****ALPHA, BETA, AND GAMMA ALL DIFFERENT FROM 90 DEGREES*****
C
C     SET CELL AS A TYPE 1 CELL (+++) - ALL ANGLES LESS THAN 90 DEGREES
C     OR AS A TYPE 2 CELL (---) - ALL ANGLES GREATER THAN 90 DEGREES.
C
C
40    IF (SF23.GT.Z.AND.SF13.GT.Z.AND.SF12.GT.Z) ITYPE=1
      IF (SF23.LE.Z.AND.SF13.LE.Z.AND.SF12.LE.Z) ITYPE=2
      IF (ITYPE.EQ.1.OR.ITYPE.EQ.2) GO TO 105
C
C     NON-STANDARD(+--) TO (+++)
C
      IF (SF23.GT.Z.AND.SF13.LE.Z.AND.SF12.LE.Z) GO TO 45
      GO TO 50
45    SF23=ABS(SF23)
      SF13=ABS(SF13)
      SF12=ABS(SF12)
      U(1)=1.0
      U(5)=-1.0
      U(9)=-1.0
      CALL MATRIX (U,T,P)
      ITYPE=1
      GO TO 100
C
C     NON-STANDARD(-+-) TO (+++)
C
50    IF (SF23.LE.Z.AND.SF13.GT.Z.AND.SF12.LE.Z) GO TO 55
      GO TO 60
55    SF23=ABS(SF23)
      SF13=ABS(SF13)
      SF12=ABS(SF12)
      U(1)=-1.0
      U(5)=1.0
      U(9)=-1.0
      CALL MATRIX (U,T,P)
      ITYPE=1
      GO TO 100
C
C     NON-STANDARD(--+) TO (+++)
C
60    IF (SF23.LE.Z.AND.SF13.LE.Z.AND.SF12.GT.Z) GO TO 65
      GO TO 70
65    SF23=ABS(SF23)
      SF13=ABS(SF13)
      SF12=ABS(SF12)
      U(1)=-1.0
      U(5)=-1.0
      U(9)=1.0
      CALL MATRIX (U,T,P)
      ITYPE=1
      GO TO 100
C
C     NON-STANDARD(++-) TO (---)
C
70    IF (SF23.GT.Z.AND.SF13.GT.Z.AND.SF12.LE.Z) GO TO 75
      GO TO 80
75    SF23=-ABS(SF23)
      SF13=-ABS(SF13)
      SF12=-ABS(SF12)
      U(1)=-1.0
      U(5)=-1.0
      U(9)=1.0
      CALL MATRIX (U,T,P)
      ITYPE=2
      GO TO 100
C
C     NON-STANDARD(+-+) TO (---)
C
80    IF (SF23.GT.Z.AND.SF13.LE.Z.AND.SF12.GT.Z) GO TO 85
      GO TO 90
85    SF23=-ABS(SF23)
      SF13=-ABS(SF13)
      SF12=-ABS(SF12)
      U(1)=-1.0
      U(5)=1.0
      U(9)=-1.0
      CALL MATRIX (U,T,P)
      ITYPE=2
      GO TO 100
C
C     NON-STANDARD(-++) TO (---)
C
90    IF (SF23.LE.Z.AND.SF13.GT.Z.AND.SF12.GT.Z) GO TO 95
      GO TO 105
95    SF23=-ABS(SF23)
      SF13=-ABS(SF13)
      SF12=-ABS(SF12)
      U(1)=1.0
      U(5)=-1.0
      U(9)=-1.0
      CALL MATRIX (U,T,P)
      ITYPE=2
100   CONTINUE
C
      CALL RESET
C
105   CONTINUE
       IF(ITYPE.NE.0) RETURN
        WRITE(*,110)
        WRITE(nout,110)
      IERR=IERR+1
110   FORMAT(1H ,44H**ERROR**SUBROUTINE NORM FAILED TO TYPE CELL)
      RETURN
      END
*COPY REDUC
      SUBROUTINE REDUC
C
c     This routine was adapted from NBS*AIDS80 (Mighell, Hubbard & Stali
c
C        **********REDUCE THE CELL**********
C
      common long,nout,idm,inf,isc,ipol,r,ngr,iocfl,vol,nfl,volrat
      common /cel/af,bf,cf,al,be,ga,aalp,abet,agam,cosa,cosb,cosg
      COMMON/DOTS/SF11,SF22,SF33,SF23,SF13,SF12,ITYPE,DOTAB,DOTAC,DOTBC
      COMMON/GARB/ ierr, igo, ired ,e1 ,ithru
      common /trans/uvw(9),u(9),t(9),p(9)
C
      ithru = 0
      ICT=0
      IT=0
      IX=0
C
C     CALCULATE SCALARS
C
      S11=AF**2
      S22=BF**2
      S33=CF**2
      S23=BF*CF*COS(AALP)
      S13=AF*CF*COS(ABET)
      S12=AF*BF*COS(AGAM)
C
      IF (ABS(Al-90.0000).LT.0.0001) S23=0
      IF (ABS(ga-90.0000).LT.0.0001) S12=0
      IF (ABS(be-90.0000).LT.0.0001) S13=0
      A23=ABS(S23)
      A13=ABS(S13)
      A12=ABS(S12)
5     IF (2.0*A23-S22) 15,15,10
10    IF (S23) 45,20,50
15    IF (2.0*A23-S33) 20,20,10
20    IF (2.0*A13-S11) 25,25,135
25    IF (2.0*A13-S33) 30,30,135
30    IF (2.0*A12-S11) 35,35,230
35    IF (2.0*A12-S22) 40,40,230
40    A=SQRT(S11)
      B=SQRT(S22)
      C=SQRT(S33)
      COSA=S23/(B*C)
      COSB=S13/(A*C)
      COSG=S12/(A*B)
      GO TO 325
45    CONTINUE
      XN=1.0
      GO TO 55
50    XN=-1.0
55    XN1=0.0
60    R23=ABS(S23+XN*S22)
      IF (R23-A23) 65,65,85
65    IF (S23) 70,75,75
70    XN=XN+1.0
      XN1=XN1+1.0
      GO TO 80
75    XN=XN-1.0
      XN1=XN1-1.0
80    A23=R23
      GO TO 60
85    S33=S33+(XN1**2)*S22+2.0*XN1*S23
      S23=S23+XN1*S22
      S13=S13+XN1*S12
      A23=ABS(S23)
      A13=ABS(S13)
      CALL SET
      U(1)=1.0
      U(5)=1.0
      U(8)=XN1
      U(9)=1.0
      IT=1
      CALL MATRIX (U,T,P)
      CALL RESET
      IF (S23) 95,20,90
90    XN=-1.0
      GO TO 100
95    XN=1.0
100   XN1=0.0
105   R23=ABS(S23+XN*S33)
      IF (R23-A23) 110,110,130
110   IF (S23) 115,120,120
115   XN=XN+1.0
      XN1=XN1+1.0
      GO TO 125
120   XN=XN-1.0
      XN1=XN1-1.0
125   A23=R23
      GO TO 105
130   S22=S22+(XN1**2)*S33+2.0*XN1*S23
      S23=S23+XN1*S33
      S12=S12+(XN1*S13)
      A23=ABS(S23)
      A12=ABS(S12)
      CALL SET
      U(1)=1.0
      U(5)=1.0
      U(6)=XN1
      U(9)=1.0
      IT=2
      CALL MATRIX (U,T,P)
      CALL RESET
      GO TO 5
135   CONTINUE
      IF (S13) 145,145,140
140   XN=-1.0
      GO TO 150
145   XN=1.0
150   XN1=0.0
      R13=ABS(S13+XN*S11)
155   IF (R13-A13) 160,160,180
160   IF (S13) 175,165,165
165   XN=XN-1.0
      XN1=XN1-1.0
170   A13=R13
      R13=ABS(S13+XN*S11)
      GO TO 155
175   XN=XN+1.0
      XN1=XN1+1.0
      GO TO 170
180   CONTINUE
      S33=S33+(XN1**2)*S11+2.0*XN1*S13
      S13=S13+XN1*S11
      S23=S23+XN1*S12
      A13=ABS(S13)
      A23=ABS(S23)
      CALL SET
      U(1)=1.0
      U(5)=1.0
      U(7)=XN1
      U(9)=1.0
      IT=3
      CALL MATRIX (U,T,P)
      CALL RESET
      IF (S13) 190,190,185
185   XN=-1.0
      GO TO 195
190   XN=1.0
195   XN1=0.0
200   R13=ABS(S13+XN*S33)
      IF (R13-A13) 210,210,205
205   S11=S11+(XN1**2)*S33+2.0*XN1*S13
      S13=S13+XN1*S33
      S12=S12+XN1*S23
      A13=ABS(S13)
      A12=ABS(S12)
      CALL SET
      U(1)=1.0
      U(3)=XN1
      U(5)=1.0
      U(9)=1.0
      IT=4
      CALL MATRIX (U,T,P)
      CALL RESET
      GO TO 5
210   IF (S13) 215,220,220
215   XN=XN+1.0
      XN1=XN1+1.0
      GO TO 225
220   XN=XN-1.0
      XN1=XN1-1.0
225   A13=R13
      GO TO 200
230   IF (S12) 235,235,240
235   XN=1.0
      GO TO 245
240   XN=-1.0
245   XN1=0.0
250   R12=ABS(S12+XN*S11)
      IF (R12-A12) 255,255,275
255   IF (S12) 260,265,265
260   XN=XN+1.0
      XN1=XN1+1.0
      GO TO 270
265   XN=XN-1.0
      XN1=XN1-1.0
270   A12=R12
      GO TO 250
275   S22=S22+(XN1**2)*S11+2.0*XN1*S12
      S12=S12+XN1*S11
      S23=S23+XN1*S13
      A12=ABS(S12)
      A23=ABS(S23)
      CALL SET
      U(1)=1.0
      U(4)=XN1
      U(5)=1.0
      U(9)=1.0
      IT=5
      CALL MATRIX (U,T,P)
      CALL RESET
      IF (S12) 285,285,280
280   XN=-1.0
      GO TO 290
285   XN=1.0
290   XN1=0.0
295   R12=ABS(S12+XN*S22)
      IF (R12-A12) 300,300,320
300   IF (S12) 310,305,305
305   XN=XN-1.0
      XN1=XN1-1.0
      GO TO 315
310   XN=XN+1.0
      XN1=XN1+1.0
315   A12=R12
      GO TO 295
320   S11=S11+(XN1**2)*S22+2.0*XN1*S12
      S12=S12+XN1*S22
      S13=S13+XN1*S23
      A12=ABS(S12)
      A13=ABS(S13)
      CALL SET
      IT=6
      U(1)=1.0
      U(2)=XN1
      U(5)=1.0
      U(9)=1.0
      CALL MATRIX (U,T,P)
      CALL RESET
      GO TO 5
C
C-----ARRANGE SO A.LE.B. AND B.LE.C
C
325   CONTINUE
      CALL SET
      IF (A-B) 330,330,345
330   IF (A-C) 335,335,370
335   T1=A
      IF (B-C) 340,340,375
340   T2=B
      T3=C
      E23=COSA
      E13=COSB
      E12=COSG
      GO TO 385
C
C
345   IF (A-C) 365,365,350
350   T3=A
      IF (B-C) 360,360,355
355   T1=C
      T2=B
      E12=COSA
      E13=-COSB
      E23=-COSG
      U(3)=1.0
      U(5)=1.0
      U(7)=-1.0
      IX=1
      CALL MATRIX (U,T,P)
      GO TO 380
360   T1=B
      T2=C
      E12=COSA
      E13=COSG
      E23=COSB
      U(2)=1.0
      U(6)=1.0
      U(7)=1.0
      IX=2
      CALL MATRIX (U,T,P)
      GO TO 380
365   T1=B
      T2=A
      T3=C
      E12=COSG
      E13=-COSA
      E23=-COSB
      U(2)=1.0
      U(4)=1.0
      U(9)=-1.0
      IX=3
      CALL MATRIX (U,T,P)
      GO TO 380
370   T1=C
      T2=A
      T3=B
      E12=COSB
      E13=COSA
      E23=COSG
      U(3)=1.0
      U(4)=1.0
      U(8)=1.0
      IX=4
      CALL MATRIX (U,T,P)
      GO TO 380
375   T2=C
      T3=B
      E12=COSB
      E13=-COSG
      E23=-COSA
      U(1)=1.0
      U(6)=1.0
      U(8)=-1.0
      IX=5
      CALL MATRIX (U,T,P)
380   CONTINUE
      CALL RESET
385   A=T1
      B=T2
      C=T3
      COSA=E23
      COSB=E13
      COSG=E12
C
C
      SF11=A**2
      SF22=B**2
      SF33=C**2
      SF23=B*C*COSA
      SF13=A*C*COSB
      SF12=A*B*COSG
C
C     PUT CELL IN NORMAL REPRESENTATION
C
      CALL NORM
      IF (ITYPE.EQ.2) GO TO 390
      GO TO 400
C
C     TYPE 2 CELL.  NOW CHECK PART 2 OF MAIN CONDITIONS.
C
390   CALL SET
      TX1=SF11+SF22
      TX2=2.0*(ABS(SF23)+ABS(SF13)+ABS(SF12))
      ICT=ICT+1
      IF(ICT.LE.2) GOTO 396
      GOTO 400
  396 IF (TX1.GE.TX2) GO TO 400
      SF33=SF11+SF22+SF33+2.0*SF12+2.0*SF13+2.0*SF23
      SF23=SF12+SF23+SF22
      SF13=SF11+SF12+SF13
      U(1)=1.0
      U(2)=0.0
      U(3)=0.0
      U(4)=0.0
      U(5)=1.0
      U(6)=0.0
      U(7)=1.0
      U(8)=1.0
      U(9)=1.0
      CALL MATRIX (U,T,P)
      CALL RESET
      A=SQRT(SF11)
      B=SQRT(SF22)
      C=SQRT(SF33)
      COSA=SF23/(B*C)
      COSB=SF13/(A*C)
      COSG=SF12/(A*B)
      GO TO 325
400   CALL NIGGLI
      ICOUNT=0
C        **********CELL BASED ON 3 SHORTEST VECTORS**********
C                 ****CHECK SPECIAL CONDITIONS****
C
405   CALL NORM
      CALL NIGGLI
      IF (IRED.EQ.1) GO TO 420
      IF (IGO.LT.1.OR.IGO.GT.9) GO TO 410
C
C     CELL NOT REDUCED. *IGO* TELLS PROGRAM WHERE TO GO IN *SPECON* TO
C     SATISFY SPECIAL CONDITION.
C
      CALL SPECON
      ICOUNT=ICOUNT+1
      IF (ICOUNT.LT.20) GO TO 405
410   WRITE(*,415)
      WRITE(nout,415)
      IERR=IERR+1
415   FORMAT(' **ERROR**PROGRAM FAILS AT END OF SUBROUTINE REDUC')
  420 return
      END
*COPY SET
      SUBROUTINE SET
C
C        *****PREPARE FOR MATRIX MULTIPLICATION*****
C
      COMMON/TRANS/ uvw(9),U(9),T(9),P(9)
C
      DO 5 I=1,9
      t(i) = uvw(i)
      U(I)=0.0
5     CONTINUE
      RETURN
      END
*COPY SETM
      SUBROUTINE SETM(nbr)
C
C
c     This routine was adapted from NBS*AIDS80 (Mighell, Hubbard & Stali
c
c     called by CELRDN
C        ASSIGNS INITIAL TRANSFORMATION MATRIX
C     ******************************************************************
C
      common long,nout,idm,inf,isc,ipol,r,ngr,iocfl,vol,nfl,volrat
      COMMON/TRANS/ U1,V1,W1,U2,V2,W2,U3,V3,W3,U(9),T(9),P(9)
C
C
      GOTO (60,40,50,10,20,90) , nbr
c     these are respectively : P, A, C, F, I and R centrings
C
   10 continue
C     F-CENTERED CELL
      U1=0.5
      V1=0.5
      W1=0.0
      U2=0.
      V2=0.5
      W2=0.5
      U3=0.5
      V3=0.0
      W3=0.5
      GO TO 120
C
20    CONTINUE
C
C
C     I-CENTERED CELL
      U1=0.5
      V1=0.5
      W1=-.5
      U2=-.5
      V2=0.5
      W2=0.5
      U3=0.5
      V3=-.5
      W3=.5
      GO TO 120
C
C
40    CONTINUE
C
C     A-CENTERED LATTICE
C
      U1=0.
      V1=0.5
      W1=-.5
      U2=0.
      V2=0.5
      W2=.5
      U3=1.
      V3=.0
      W3=0.
      GO TO 120
C
50    CONTINUE
C
C
C     C-CENTERED LATTICE
      U1=.5
      V1=-.5
      W1=.0
      U2=.5
      V2=.5
      W2=.0
      U3=.0
      V3=.0
      W3=1.
      GO TO 120
C
C     PRIMITIVE LATTICE
C
60    CONTINUE
      U1=1.0
      V1=0.0
      W1=0.0
      U2=0.0
      V2=1.0
      W2=0.0
      U3=0.0
      V3=0.0
      W3=1.0
C
      GO TO 120
C
90    CONTINUE
C
C     RHOMBOHEDRAL HEXAGONAL AXES TO RHOMBOHEDRAL PRIMITIVE
      c1 = 1./3.
      c2 = 2./3.
      U1=c1
      V1=-c1
      W1=-c1
      U2=-c2
      V2=-c1
      W2=-c1
      U3=c1
      V3= c2
      W3=-c1
      GO TO 120
C
C
C
120   return
      end
*COPY SPECON
      SUBROUTINE SPECON
C
c     This routine was adapted from NBS*AIDS80 (Mighell, Hubbard & Stali
c
C   ****TRANSFORMS CELL SO THAT THE SPECIAL CONDITIONS ARE SATISFIED****
C
      COMMON/DOTS/SF11,SF22,SF33,SF23,SF13,SF12,ITYPE,DOTAB,DOTAC,DOTBC
      COMMON/GARB/  ierr, igo, ired ,E1,ithru
      COMMON/TRANS/ UVW(9),U(9),T(9),P(9)
C
      CALL SET
      SSF23=SF23
      SSF13=SF13
      SSF12=SF12
      GO TO (5,10,15,20,25,30,35,40,45), IGO
5     SF23=SSF13
      SF13=SSF23
      SF12=SSF12
      U(2)=-1.0
      U(4)=-1.0
      U(9)=-1.0
      CALL MATRIX (U,T,P)
      GO TO 50
10    SF23=SSF23
      SF13=SSF12
      SF12=SSF13
      U(1)=-1.0
      U(6)=-1.0
      U(8)=-1.0
      CALL MATRIX (U,T,P)
      GO TO 50
15    SF23=SSF23
      SF13=SSF12-SSF13
      SF12=SSF12
      U(1)=-1.0
      U(5)=-1.0
      U(8)=-1.0
      U(9)=1.0
      CALL MATRIX (U,T,P)
      GO TO 50
20    SF23=SSF12-SSF23
      SF13=SSF13
      SF12=SSF12
      U(1)=-1.0
      U(5)=-1.0
      U(7)=-1.0
      U(9)=1.0
      CALL MATRIX (U,T,P)
      GO TO 50
25    SF23=SSF13-SSF23
      SF13=SSF13
      SF12=SSF12
      U(1)=-1.0
      U(4)=-1.0
      U(5)=1.0
      U(9)=-1.0
      CALL MATRIX (U,T,P)
      GO TO 50
30    SF23=ABS(SSF23)
      SF13=ABS(SSF13)+ABS(SSF12)
      SF12=ABS(SSF12)
      U(1)=1.0
      U(5)=-1.0
      U(8)=-1.0
      U(9)=-1.0
      CALL MATRIX (U,T,P)
      GO TO 50
35    SF23=ABS(SSF23)+ABS(SSF12)
      SF13=ABS(SSF13)
      SF12=ABS(SSF12)
      U(1)=-1.0
      U(5)=1.0
      U(7)=-1.0
      U(9)=-1.0
      CALL MATRIX (U,T,P)
      GO TO 50
40    SF23=ABS(SSF23)+ABS(SSF13)
      SF13=ABS(SSF13)
      SF12=ABS(SSF12)
      U(1)=-1.0
      U(4)=-1.0
      U(5)=-1.0
      U(9)=1.0
      CALL MATRIX (U,T,P)
      GO TO 50
45    SF23=ABS(SSF12)+ABS(SSF23)-SF22
      SF13=ABS(SSF12)+ABS(SSF13)-SF11
      SF12=SSF12
      U(1)=-1.0
      U(5)=-1.0
      U(7)=1.0
      U(8)=1.0
      U(9)=1.0
      CALL MATRIX (U,T,P)
50    CONTINUE
      CALL RESET
      RETURN
      END
*COPY SYMTST
      SUBROUTINE SYMTST(iseq)
C
c     This routine was adapted from NBS*AIDS80 (Mighell, Hubbard & Stali
C
      common long,nout,idm,inf,isc,ipol,r,ngr,iocfl,vol,nfl,volrat
      common /cel/ a,b,c,al,be,ga,alf,bet,gam,cosa,cosb,cosg
C
C-----SYMTST TESTS FOR EQUALITY OF DOT PRODUCTS BASED ON DIFFERENCES
C-----BEING SMALLER THAT A PRESET VALUE FOR THE RELATIVE ERROR IN A*A
C-----B*B, C*C, B*C, A*C OR A*B.
C
C-----THE RELATIVE ERROR Q IS SET TO 0.004
C-----THE INCREMENT DQ INSURES THAT Q*E>0 NEAR 90 DEG
C
C
C-----FLAGS 1,2,3 TO TEST WHAT IS EQUAL
C-----NEG INDICATES THE REDUCED FORM TYPE (- OR +)
      q = .004
      DQ=0.04
      IFLAG1=0
      IFLAG2=0
      IFLAG3=0
      NEG=1
      ISEQ=0
      e1 = a**2
      e2 = b**2
      e3 = c**2
      e4 = cosa*b*c
      e5 = cosb*a*c
      e6 = cosg*a*b
      ONE=ABS(E1-E3)
      TWO=ABS(E1-E2)
      THREE=ABS(E2-E3)
C-----TEST FOR A=B=C
      IF(ONE.LT.(Q*E3))IFLAG1=1
C-----TEST FOR A=B
      IF(TWO.LT.(Q*E2))IFLAG2=1
C-----TEST FOR B=C
      IF(THREE.LT.(Q*E3))IFLAG3=1
C-----DETERMINE REDUCED FORM TYPE (- OR +) BASED ON TRUE REDUCED CELL
      IF(e4.LT.Q.AND.e5.LT.Q.AND.e6.LE.Q)NEG=-1
      IF(e4.GT.Q.AND.e5.GT.Q.AND.e6.GE.Q)NEG=0
      IF(NEG.NE.1)GO TO 20
      NEG=-1
      IF(AL.LT.89.99.OR.BE.LT.89.99.OR.GA.LT.89.99)NEG=0
      WRITE(*,10)
      WRITE(NOUT,10)
   10 FORMAT(1H ,42H**WARNING**REDUCED FORM MAY NOT BE CORRECT)
   20 IF(IFLAG1.EQ.1)GO TO 600
      IF(IFLAG2.EQ.1)GO TO 700
      IF(IFLAG3.EQ.1)GO TO 800
      GO TO 900
C
C-----REDUCED FORM WITH A=B=C    (NUMBERS 1 TO 8)
C
600   CONTINUE
      IF(NEG.EQ.-1)GO TO 650
      X=E1/2.
      IF(ABS(E4-X).LT.(E4*Q+DQ).AND.ABS(E5-X).LT.(E5*Q+DQ).AND.ABS(E6-X)
     2.LT.(E6*Q+DQ))ISEQ=1
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E4-E5).LT.(E4*Q+DQ).AND.ABS(E5-E6).LT.(E5*Q+DQ))ISEQ=2
      IF(ISEQ.NE.0)GO TO 999
      GO TO 700
650   CONTINUE
      Z=E1/3.
      IF((ABS(E4)+ABS(E5)+ABS(E6)).LT.(DQ*3.))ISEQ=3
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E4+Z).LT.(ABS(E4*Q)+DQ).AND.ABS(E5+Z).LT.(ABS(E5*Q)+DQ).AND
     2.ABS(E6+Z).LT.(ABS(E6*Q)+DQ))ISEQ=5
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E4-E5).LT.(ABS(E4*Q)+DQ).AND.ABS(E5-E6).LT.(ABS(E5*Q)+DQ))
     2ISEQ=4
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E4-E5).LT.(ABS(E4*Q)+DQ).AND.ABS((E6+E1)/2.+E4).LT.(ABS(E4*
     2Q)+DQ))ISEQ=6
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E5-E6).LT.(ABS(E5*Q)+DQ).AND.ABS((E4+E1)/2.+E5).LT.(ABS(E5*
     2Q)+DQ))ISEQ=7
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E1+E4+E5+E6).LT.(ABS(E6*Q)+DQ))ISEQ=8
      IF(ISEQ.NE.0)GO TO 999
      GO TO 750
C
C-----REDUCED FORMS WITH A=B   (NUMBERS 9 TO 17)
C
700   CONTINUE
      IF(NEG.EQ.-1)GO TO 750
      X=E1/2.
      IF(ABS(E4-X).LT.(E4*Q+DQ).AND.ABS(E5-X).LT.(E5*Q+DQ).AND.ABS(E6-X)
     2.LT.(E6*Q+DQ))ISEQ=9
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E4-E5).LT.(ABS(E4*Q)+DQ))ISEQ=10
      IF(ISEQ.NE.0)GO TO 999
      GO TO 800
750   CONTINUE
      X=E1/2.
      IF(ABS(E4+E5).LT.(DQ*2.).AND.ABS(E6+X).LT.(ABS(E6*Q)+DQ))ISEQ=12
      IF(ISEQ.NE.0)GO TO 999
      IF((ABS(E4)+ABS(E5)+ABS(E6)).LT.(DQ*3.))ISEQ=11
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E4-E5).LT.(ABS(E4*Q)+DQ).AND.ABS(E4+X).LT.(ABS(E4*Q)+DQ))
     2ISEQ=15
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E4+E5).LT.(DQ*2.))ISEQ=13
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E4-E5).LT.(ABS(E4*Q)+DQ).AND.ABS(E1+2.*E4+E6).LT.(ABS(E6*Q)
     2+DQ))ISEQ=16
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E1+E4+E5+E6).LT.(ABS(E6*Q)+DQ))ISEQ=17
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E4-E5).LT.(ABS(E4*Q)+DQ))ISEQ=14
      IF(ISEQ.NE.0)GO TO 999
      GO TO 850
C
C-----REDUCED FORMS WITH B=C    (NUMBERS 18 TO 25)
C
800   CONTINUE
      IF(ABS(b-c).GT.ABS(b*Q))GO TO 900
      IF(NEG.EQ.-1)GO TO 850
      X=E1/2.
      IF(ABS(E4-X/2.).LT.(ABS(E4*Q)+DQ).AND.ABS(E5-E6).LT.(ABS(E5*Q)+DQ)
     2.AND.ABS(E5-X).LT.(ABS(E5*Q)+DQ))ISEQ=18
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E5-E6).LT.(ABS(E5*Q)+DQ).AND.ABS(E5-X).LT.(ABS(E5*Q)+DQ))
     2ISEQ=19
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E5-E6).LT.(ABS(E5*Q)+DQ))ISEQ=20
      IF(ISEQ.NE.0)GO TO 999
      GO TO 900
850   CONTINUE
      IF(ABS(b-c).GT.ABS(b*Q))GO TO 950
      Y=E2/2.
      IF(ABS(((E2-E1/3.)/2.)+E4).LT.(ABS(E4*Q)+DQ).AND.ABS(E5-E6).LT.(AB
     2S(E5*Q)+DQ).AND.ABS(E5+E1/3.).LT.(ABS(E5*Q)+DQ))ISEQ=24
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E6+E5).LT.(DQ*2.).AND.ABS(E4+Y).LT.(ABS(E4*Q)+DQ))ISEQ=22
      IF(ISEQ.NE.0)GO TO 999
      IF((ABS(E4)+ABS(E5)+ABS(E6)).LT.(DQ*3.))ISEQ=21
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E6+E5).LT.(DQ*2.))ISEQ=23
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E5-E6).LT.(ABS(E5*Q)+DQ))ISEQ=25
      IF(ISEQ.NE.0)GO TO 999
      GO TO 950
C
C-----REDUCED FORMS WITH A.NE.B.NE.C   (NUMBERS 26 TO 44)
C
900   CONTINUE
      IF(NEG.EQ.-1)GO TO 950
      X=E1/2.
      Y=E2/2.
      IF(ABS(E4-X/2.).LT.(ABS(E4*Q)+DQ).AND.ABS(E5-E6).LT.(ABS(E5*Q)+DQ)
     2.AND.ABS(E5-X).LT.(ABS(E5*Q)+DQ))ISEQ=26
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E5-E6).LT.(ABS(E5*Q)+DQ).AND.ABS(E5-X).LT.(ABS(E5*Q)+DQ))
     2ISEQ=27
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E4-E6/2.).LT.(ABS(E4*Q)+DQ).AND.ABS(E5-X).LT.(ABS(E5*Q)+DQ)
     2)ISEQ=28
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E4-E5/2.).LT.(ABS(E4*Q)+DQ).AND.ABS(E6-X).LT.(ABS(E6*Q)+DQ)
     2)ISEQ=29
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E4-Y).LT.(ABS(E4*Q)+DQ).AND.ABS(E5-E6/2.).LT.(ABS(E5*Q)+DQ)
     2)ISEQ=30
      IF(ISEQ.NE.0)GO TO 999
      ISEQ=31
      GO TO 999
950   CONTINUE
      X=E1/2.
      Y=E2/2.
      IF((ABS(E4)+ABS(E5)+ABS(E6)).LT.(DQ*3.))ISEQ=32
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E6+E4).LT.(DQ*2.).AND.ABS(E5+X).LT.(ABS(E5*Q)+DQ))ISEQ=36
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E5+E4).LT.(DQ*2.).AND.ABS(E6+X).LT.(ABS(E6*Q)+DQ))ISEQ=38
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E6+E5).LT.(DQ*2.).AND.ABS(E4+Y).LT.(ABS(E4*Q)+DQ))ISEQ=40
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E6).LT.DQ.AND.ABS(E4+Y).LT.(ABS(E4*Q)+DQ).AND.ABS(E5+X).LT.
     2(ABS(E5*Q)+DQ))ISEQ=42
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E4+E6).LT.(DQ*2.))ISEQ=33
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E4+E5).LT.(DQ*2.))ISEQ=34
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E6+E5).LT.(DQ*2.))ISEQ=35
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E5+X).LT.(ABS(E5*Q)+DQ).AND.ABS(E6).LT.DQ)ISEQ=37
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E6+X).LT.(ABS(E6*Q)+DQ).AND.ABS(E5).LT.DQ)ISEQ=39
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E4+Y).LT.(ABS(E4*Q)+DQ).AND.ABS(E6).LT.DQ)ISEQ=41
      IF(ISEQ.NE.0)GO TO 999
      IF(ABS(E4+(E2+E6)/2.).LT.(ABS(E4*Q)+DQ).AND.ABS(E5+(E1+E6)/2.).LT.
     2(ABS(E5*Q)+DQ))ISEQ=43
      IF(ISEQ.NE.0)GO TO 999
      ISEQ=44
999   CONTINUE
      RETURN
      END
