$LARGE
*COPY CHOICE
      subroutine CHOICE(natom,ii,ig,k,nr,newnr)
c
c     called by RESULT, subroutine of STIDY
c     makes final choice between various standardizations
c     ig is number of possible settings (max nset).
c     if ii=1 minimum of 'sum' should be found; if ii=2, of 'horsum'
c
      PARAMETER(numat=150,nset =120)
      common long,nout,idm,inf,isc,ipol,r,ngr,iocfl,vol,nfl,volrat
      common /ord/ x(3,numat),mul(numat),let(numat),
     1 horsum(numat,nset),sum(3,nset),sxy(nset),sxz(nset),syz(nset)
      dimension nr(nset),newnr(nset),new(nset)
 
      do 35 i=1,nset
   35 newnr(i) = 0
      kk = 1
      if(ii.eq.2) go to 50
c     find minimum sum
      do 1 i=1,3
      s = 1000000.
      do 2 j=1,ig
      m = nr(j)
*     look if this setting is in array newnr (only possible if i>1):
      if(i.gt.1) then
        do 11 l=1,kk
        if(m.eq.newnr(l)) go to 6
   11   continue
        go to 2
      endif
 
    6 if(s.gt.sum(i,m)) s = sum(i,m)
    2 continue
 
c-----is this minimum sum unique ?
      k = 0
      do 3 j=1,ig
      l = nr(j)
*     look if this setting is in array newnr
      if(i.gt.1) then
        do 12 m=1,kk
        if(l.eq.newnr(m)) go to 7
   12   continue
        go to 3
      endif
    7 if(abs(sum(i,l)-s).lt.0.0001) then
        k = k + 1
        newnr(k) = l
      endif
    3 continue
 
      if(k.le.1) return
 
c     k > 1 ; more than one minimum sum. Look at next sum for the
c     settings whose numbers are in  newnr(1..k)
 
      kk = k
 
    1 continue
 
c     if we get here, it means we return with several possibilities.
      return
 
*     come here for ii=2 : horizontal sums after ordering of atoms
   50 do 10 i=1,natom
      s = 1000000.
      do 15 j=1,ig
      m = nr(j)
*     look if this setting is in array new (only possible if i>1):
      if(i.gt.1) then
        do 13 l=1,kk
        if(m.eq.newnr(l)) go to 8
   13   continue
        go to 15
      endif
    8 if(s.gt.horsum(i,j)) s = horsum(i,j)
 
 
   15 continue
c
c-----is this minimum sum unique ?
      k = 0
      do 30 j=1,ig
      l = nr(j)
*     look if this setting is in array newnr
      if(i.gt.1) then
        do 14 m=1,kk
        if(j.eq.new(m)) go to 9
   14   continue
        go to 30
      endif
    9 if(abs(horsum(i,j)-s).lt.0.0001) then
        k = k + 1
        new(k) =  j
        newnr(k) = nr(j)
      endif
   30 continue
 
      if(k.le.1) return
 
c     k > 1 ; more than one minimum sum. Look at next sum for the
c     settings whose numbers are in  newnr(1..k)
 
      kk = k
 
   10 continue
      return
      end
*COPY CELOUT
      subroutine CELOUT(ngr,ca,cb,cc,cal,cbe,cga)
*
*     called by RESULT, makes charactervariables out of cellparameters
*     for writing on unit 12
*
      common /cel/ a,b,c,al,be,ga,alf,bet,gam,cosa,cosb,cosg
      character*8 ca,cb,cc
      character*9 cal,cbe,cga
*
      write(ca,'(f8.4)') a
      write(cb,'(f8.4)') b
      write(cc,'(f8.4)') c
      write(cal,'(f9.3)') al
      write(cbe,'(f9.3)') be
      write(cga,'(f9.3)') ga
*
      if(ngr.ge.3.and.ngr.le.15) then
        cal = ' '
        cga = ' '
      else if(ngr.ge.16.and.ngr.le.74) then
        cal = ' '
        cbe = ' '
        cga = ' '
      else if(ngr.ge.75.and.ngr.le.142) then
        cb = ' '
        cal = ' '
        cbe = ' '
        cga = ' '
      else if(ngr.ge.143.and.ngr.le.194) then
        cb = ' '
        cal = ' '
        cbe = ' '
        cga = '  120.   '
      else if(ngr.ge.195) then
        cb = ' '
        cc = ' '
        cal = ' '
        cbe = ' '
        cga = ' '
      endif
      return
      end
*COPY CODREC
      subroutine CODREC(ipears,pmin,cpears,nelt,pear,cpear)
 
*     called from RESULT; writes abundances nearer to elements
      PARAMETER(nelts=8)
      character cpears*10,cpear(nelts)*7,aux1*6,aux*7
      dimension pear(nelts)
 
*     Pearsoncode :
      cpears = ' '
      aux  = ' '
      aux1 = ' '
      write(aux1,'(i6)') ipears
      k = 0
      do 10 j=1,6
      if(aux1(j:j).eq.' ') go to 10
      k = k + 1
      cpears(k:k) = aux1(j:j)
   10 continue
 
      if(pmin.eq.0.) go to 20
      k = k + 1
      cpears(k:k) = '-'
      write(aux1,'(f6.2)') pmin
      do 15 j=1,6
      if(aux1(j:j).eq.' ') go to 15
      k = k + 1
      cpears(k:k) = aux1(j:j)
   15 continue
 
*     abundances of elements :
   20 do 50 i=1,nelt
      k=0
      cpear(i) = ' '
      write(aux,'(f7.3)') pear(i)
      do 45 j=1,7
      if(aux(j:j).eq.' ') go to 45
      if(aux(j:j).ne.'.') then
        k = k + 1
        cpear(i)(k:k) = aux(j:j)
      else
        k = k + 1
        cpear(i)(k:k) = '.'
      go to 55
      endif
   45 continue
 
   55 do 25 l=j+1,7
      if(aux(l:l).ne.'0') go to 30
   25 continue
*     nothing after decimal point; go on with next element
      go to 50
*     come here if digits after decimal point :
   30 do 35 l=j+1,7
      if(aux(l:l).eq.' ') go to 50
      k = k + 1
      cpear(i)(k:k) = aux(l:l)
   35 continue
   50 continue
      return
      end
*COPY EDIT
      subroutine EDIT(x1,x2,x3,nsp,coord)
*      called by ORDER; edits atomcoordinates for final results with
*      fractions or 0 where indicated by special position
*
      PARAMETER(numat=150)
 
      dimension x(3),kspec(3,146)
      character*7 coord(3),koord(12)
 
      data koord/' 0     ',' 1/2   ',' 1/4   ',' 3/4   ',' 1/8   ',
     1          ' 3/8   ',' 5/8   ',' 7/8   ',' 1/3   ',' 2/3   ',
     2          ' 1/6   ',' 5/6   '/
 
      data kspec/
     1 3*2, 1,2,2, 2,1,2, 2,2,1, 2,1,1, 1,2,1, 1,1,2, 3*1, 3,3,2,
     2 3,3,1, 3,3,4, 3*3, 3,4,3, 4,3,3, 2,2,3, 1,2,3, 2,1,3, 1,1,3,
     3 3,3,2, 4,3,2, 4,3,1, 3,3,1, 3,4,1, 3,1,1, 3,1,2, 1,3,3, 1,3,4,
     4 3*5, 3,1,3, 5,5,7, 1,2,4, 3,4,2, 1,3,5, 1,3,7, 3,4,4, 4,3,4,
     5 1,4,5, 1,3,6, 9,10,1, 9,10,2, 10,9,1, 10,9,2, 9,10,3, 10,9,3,
     6 9,10,4, 3*4, 3*7, 3,2,1, 3*6, 3*8, 5,1,3, 7,1,3, 6,1,3, 8,1,3,
     7 1,4,3, 2,3,4, 8,5,5, 0,2,2, 0,2,1, 0,1,2, 0,1,1, 0,3,3, 0,1,3,
     8 0,3,4, 0,2,3, 0,3,2, 0,3,1, 0,5,5, 0,3,5, 0,4,3, 0,1,9, 0,1,12,
     9 0,1,10, 0,1,11, 2,0,2, 1,0,2, 2,0,1, 1,0,1, 2,0,3, 1,0,3, 3,0,3,
     * 3,0,1, 4,0,3, 3,0,2, 5,0,5, 2,2,0, 1,2,0, 2,1,0, 1,1,0, 3,3,0,
     a 1,3,0, 3,4,0, 3,2,0, 3,1,0, 5,5,0, 4,3,0, 9,10,0, 10,9,0, 0,0,2,
     b 0,0,1, 0,0,3, 0,2,0, 0,1,0, 0,3,0, 2,0,0, 1,0,0, 3,0,0,
     c 0,0,1, 0,0,2, 0,0,3, 0,0,4, 0,0,6, 0,0,7, 0,0,1, 0,0,2, 0,0,3,
     d 0,0,9, 0,0,10, 0,0,11, 0,0,12, 0,0,3, 0,0,2, 0,0,1, 0,0,3, 0,0,5,
     e 0,0,8, 0,0,1, 0,0,2, 0,0,3, 0,0,4, 1,0,0, 2,0,0, 3,0,0, 1,0,0,
     f 3,0,0, 3,0,0, 3,0,0, 2,0,0, 2,0,0, 5,0,0, 5,0,0, 15*0/
 
      x(1) = x1
      x(2) = x2
      x(3) = x3
      if(nsp.gt.0) then
        do 15 i=1,3
        if(kspec(i,nsp).eq.0) then
          write(coord(i),'(f7.5)') x(i)
        else
          coord(i) = koord(kspec(i,nsp))
        endif
   15   continue
      else
        do 20 i=1,3
        write(coord(i),'(f7.5)') x(i)
   20   coord(i)(1:1) = ' '
      endif
      return
      end
*COPY ORDER
      subroutine ORDER(natom,ig,ik,nelt,ax,text,o1,o2,o3,nsp)
c      called by RESULT
c-----orders atoms for output.
c     ig denotes number of descriptions with minimum gamma:
c     if ig = 0 or 1, only ordering and printing is needed;
c     if ig > 1, horizontal sum are to be computed
c     NELTS is maximum number of different elements (only NELTS elements
c     displaced in final output list). NELT is number of different
c     elements present in structure.
c     FINELT contains reordered elements.
c     NEWELT will contain (displaced) elementname
c
      PARAMETER(numat=150,nset =120, nelts = 8,ndif=30)
      common long,nout,idm,inf,isc,ipol,r,ngr,iocfl,vol,nfl,volrat
      common /bl1/ sml, aa, bb, csh
      common /bur/nt,spgr
      common /cel/ a,b,c,al,be,ga,alf,bet,gam,cosa,cosb,cosg
      common /eltname/finelt
      common /num/nel,newn,nr(ndif),maxnr(ndif)
      common /ord/ x(3,numat),mul(numat),let(numat),
     1 horsum(numat,nset),sum(3,nset),sxy(nset),sxz(nset),syz(nset)
      common /orgin/nor,orgadd(3,8),ntext,icoord
      common /res/ atom1,atom2,foc,intxt,code,elt
      common /sp/nspec,ndummy(80)
      character elt(nelts)*2,atom1(numat)*2,atom2(numat)*4,foc(numat)*5
      character*1 code(2),nt(16),sml(27),wseq(108),spgr(10)
      character newelt*9,aux*3,finelt(ndif)*2,ax*47,text*17,intxt*40
      character coord(3)*7,data*71,aa(107)*11,bb(39)*15,csh(17)*14
      dimension katom(numat),t(3,numat),ky(numat),kz(numat),nwyck(27),
     1 xx(3),nsp(numat),np(numat)
 
c     offset for conversion number -> character :
c----- ik is index in arrays sum,sxy,sxz,syz :
      kn = 1
      if(ig.lt.0) kn = -ig
      nn = 0
      eps = .0001
      kounty=0
      kountz=0
      kty=0
      ktz=0
      nspos = 0
 
      do 2 i=1,ndif
      nr(i) = 0
      maxnr(i) = 0
    2 finelt(i) = ' '
      do 25 i=1,27
   25 nwyck(i) = 0
      do 26 i=1,108
   26 wseq(i) = ' '
      kw = 0
      nel = 0
      mx = 1
      my = 1
      mz = 1
      maxord = nspec + 1
 
c     Start ordering with highest multiplicity :
      do 5 ii = 1,maxord
      k = maxord + 1 - ii
      kt = 0
      do 6 i=1,natom
      kk = let(i)
      if(kk.ne.k) go to 6
      kt = kt + 1
      do 7 j=1,3
    7 t(j,kt) = x(j,i)
      np(kt) = nsp(i)
      nspos = np(kt)
      katom(kt) = i
    6 continue
      if(kt.eq.0) go to 5
      kount = 0
    8 xmin = 2.
      meq = 0
      do 9 ix = 1,kt
      do 10 j=1,3
   10 if(t(j,ix).gt.9.) go to 9
      if(abs(t(1,ix)-xmin).lt.eps) go to 11
      if(t(1,ix)-xmin) 12,11,9
   12 xmin = t(1,ix)
      mx = ix
      meq = 0
      go to 9
   11 meq = 1
      mx = ix
    9 continue
 
      igo = 1
 
      if(meq.eq.1) go to 13
      l = katom(mx)
      call RENUM(l)
      ipos = let(l)
      if(ig.le.1) then
        xx(1) = t(1,mx)
        xx(2) = t(2,mx)
        xx(3) = t(3,mx)
        nspos = np(mx)
        ipr = 1
      else
        nn = nn + 1
        horsum(nn,ik) = t(1,mx) + t(2,mx) + t(3,mx)
        ipr = 0
      endif
      kount = kount + 1
      t(1,mx) = 10.
      if(kount.lt.kt) igo = 2
      go to 500
 
c-----get here if 2 x-positions equal; look for all equal x
   13 kty = 0
      do 14 iy = 1,kt
      if(abs(t(1,iy)-t(1,mx)).gt.eps) go to 14
      kty = kty + 1
      ky(kty) = iy
   14 continue
c
      kounty = 0
   15 ymin = 2.
      meq = 0
      do  16 j = 1,kty
      iy = ky(j)
      if(abs(t(2,iy)-ymin).lt.eps) go to  17
      if(t(2,iy)-ymin) 18,17,16
   18 ymin = t(2,iy)
      my = iy
      meq = 0
      go to 16
   17 meq = 1
      my = iy
   16 continue
 
      if(meq.eq.1) go to  20
      l = katom(my)
      call RENUM(l)
       ipos = let(l)
      if(ig.le.1) then
        ipr = 1
        xx(1) = t(1,my)
        xx(2) = t(2,my)
        xx(3) = t(3,my)
        nspos = np(my)
      else
        ipr = 0
        nn = nn + 1
        horsum(nn,ik) = t(1,my) + t(2,my) + t(3,my)
      endif
 
      kount = kount + 1
      kounty = kounty + 1
      t(2,my) = 10.
      igo = 1
      if(kounty.lt.kty) then
        igo = 3
      else if(kount.lt.kt) then
        igo = 2
      endif
      go to 500
c-----x- and y-coordinates are equal
   20 ktz = 0
      do  21 iz = 1,kt
      if(abs(t(1,mx)-t(1,iz)).gt.eps) go to  21
      if(abs(t(2,iz)-t(2,my)).gt.eps) go to  21
      ktz = ktz + 1
      kz(ktz) = iz
   21 continue
      kountz = 0
   22 zmin = 2.
      meq = 0
      do  23 j=1,ktz
      iz = kz(j)
      if(abs(t(3,iz)-zmin).lt.eps) go to  23
      if(t(3,iz)-zmin)  24, 23, 23
   24 zmin = t(3,iz)
      mz = iz
      meq = 0
      go to  23
   23 continue
      l = katom(mz)
      call RENUM(l)
      ipos = let(l)
      if(ig.le.1) then
        ipr = 1
        xx(1) = t(1,mz)
        xx(2) = t(2,mz)
        xx(3) = t(3,mz)
        nspos = np(mz)
      else
        ipr = 0
        nn = nn + 1
        horsum(nn,ik) = t(1,mz) + t(2,mz) + t(3,mz)
      endif
 
      kount = kount + 1
      kounty =  kounty + 1
      kountz =  kountz + 1
      t(3,mz) = 10.
      t(2,mz) = 10.
      igo = 1
      if(kountz.lt.ktz) then
        igo = 4
      else if(kounty.lt.kty) then
        igo = 3
      else if(kount.lt.kt) then
        igo = 2
      endif
 
  500 if(ipr.eq.1) then
        newelt = ' '
        aux = ' '
        nwyck(ipos) = nwyck(ipos) + 1
*     if atom X, put at beginning:
         if(atom1(l)(1:1).eq.'X') then
           newelt(1:2) = atom1(l)
           jj=2
           if(newelt(2:2).eq.' ') jj=1
           go to 63
         endif
c      print one line :
         do 60 i=1,nelt
         if(atom1(l).eq.elt(i)) go to 61
   60    continue
c     arrive here if error :
         write(nout,161) atom1(l),nelt
         newelt(1:2) = atom1(l)
         jj = 1
         go to 63
*     look if X-atom(s) before element i:
   61    k=0
         do 67 j=1,i
        if(elt(j)(1:1).eq.'X') go to 67
        k = k + 1
   67 continue
        k = k + 1
 
        newelt(k:k+1) = elt(i)
        jj= k + 1
        if(newelt(k+1:k+1).eq.' ')jj = k
   63   write(aux,'(i3)') newn
*     left-adjust aux:
        k=0
        do 64 j=1,3
        if(aux(j:j).eq.' ') go to 64
        k = k + 1
        aux(k:k) = aux(j:j)
   64   continue
        if(k.lt.3) aux(k+1:3) = ' '
        newelt(jj+1:jj+3) = aux
 
        call EDIT(xx(1),xx(2),xx(3),nspos,coord)
 
*     round foc if necessary (only if dot present)
        do 203 j=1,5
        if(foc(l)(j:j).eq.'.') then
          read(foc(l),'(f5.3)') ffoc
          foc(l) = ' '
          write(foc(l)(1:4),'(f4.3)') ffoc
          go to 204
        endif
  203   continue
  204   continue
        write(13,555)newelt,mul(l),sml(ipos),coord,foc(l),atom2(l)
        if(isc.eq.1) write(*,50)newelt,mul(l),sml(ipos),coord,foc(l),
     1    atom1(l),atom2(l)
      endif
  555 format('ATOM',3x,a9,1x,i3,'(',a1,')',2x,3a7,1x,a4,18x,a4)
   50 format(a14,1x,i3,'(',a1,')',2x,3a7,1x,a4,20x,a2,a4)
 
      go to (5,8,15,22),igo
    5 continue
      if(ig.gt.1) return
c
c-----Wyckoff sequence :
      j = 0
      do 30 i=27,1,-1
      if(nwyck(i).eq.0) go to 30
      j = j + 1
      wseq(j) = sml(i)
c     conversion nwyck -> characters :
      n = nwyck(i)
      if(n.gt.1) then
        write(aux,'(i3)') n
        do 31 jj=1,3            
        if(aux(jj:jj).eq.' ') go to 31
          j = j + 1
          wseq(j) = aux(jj:jj)
   31   continue
      endif
      j = j + 1
      wseq(j) = ' '
   30 continue
      if(isc.eq.1.and.long.gt.0) write(*,27) wseq
   27 format(/' Wyckoff sequence : ',108a1)
      WRITE(13,150) ngr,SPGR,(WSEQ(k),k=1,47)
  150 FORMAT('SPCGRP (',i3,') ',10A1,' - ',47A1)
      DO 28 J=48,94
      if(wseq(j).ne.' ') go to 29
   28 continue
      go to 84
   29 write(13,151) (wseq(j),j=48,94)
  151 format('SPCGRP ',26x,47a1)
 
   84 DO 88 J=95,108
      if(wseq(j).ne.' ') go to 89
   88 continue
      go to 34
   89 write(13,151) (wseq(j),j=95,108)
 
   34 call TRAFO(ax,text,o1,o2,o3)
 
c-----centre of gravity :
      cg = 0.
      if(vol.gt..0001) then
        v = vol**.333333
        if(isc.eq.1.and.long.gt.0) write(*,35) vol
*       if(long.gt.1) write(nout,35) vol
   35 format(/' Volume of unit cell : ',f10.4)
        if(volrat.gt.0..and.long.gt.0)write(nout,38) volrat
   38 format(' ratio volume Niggli-reduced cell/original cell : ',f5.2)
        cg = sqrt((a*sum(1,kn))**2+(b*sum(2,kn))**2+(c*sum(3,kn))**2
     1  +2.*(a*b*sxy(kn)*cosg+a*c*cosb*sxz(kn)+b*c*cosa*syz(kn)))/
     2  (natom*v)
      endif
      write(13,37) cg
      if(isc.eq.1.and.long.gt.0) write(*,36) cg
   36 format(/' CG parameter (centre of gravity) : ',f8.4)
   37 format('CG',f8.4)
      return
  161 format(' Element ',a2,' is not in list of first ',i2,' elements'
     1 /' so it will not have the correct indentation.')
      end
*COPY RENUM
      subroutine RENUM(l)
c     called from ORDER; renumbers atoms in final outputlist of STIDY
 
      PARAMETER(numat=150,nelts=8,ndif=30)
      common /num/nel,newn,nr(ndif),maxnr(ndif)
      common /res/ atom1,atom2,foccu,intxt,code,elt
      common /eltname/finelt
      character finelt(ndif)*2,atom1(numat)*2,atom2(numat)*4,
     1 foccu(numat)*5,intxt*40,code*2,elt(nelts)*2
c
      if(nel.eq.0) then
        finelt(1) = atom1(l)
        nel = 1
        newn = 1
        nr(1) = 1
      else
        i=1
        do 1 j=1,nel
        i = j
        if(atom1(l).eq.finelt(j)) go to 2
    1   continue
        nel = nel + 1
        newn = 1
        finelt(nel) = atom1(l)
        nr(nel) = 1
        go to 3
    2   nr(i) = nr(i) + 1
        newn = nr(i)
    3   continue
        if(newn.gt.maxnr(i)) maxnr(i) = newn
      endif
      return
      end
*COPY RESULT
      subroutine RESULT(natom,ihex,ipears,pmin,pear,nelt)
 
c     called by main of STIDY
c     reads data from scratchfile on unit 10, prints various settings, i
c     requested, and prepares for final choice.
 
      PARAMETER(numat=150,nset=120,nelts=8)
      common long,nout,idm,inf,isc,ipol,r,ngr,iocfl,vol,nfl,volrat
      common/bl1/ sml, aa, bb , csh
      common /bur/nt,spgr
      common /cel/ a,b,c,al,be,ga,alf,bet,gam,cosa,cosb,cosg
      common /lab/ ax
      common /matr/ifmat,ifsh,ifplus,xmat(3,3),plus(3),sh(3),nabc,nsh,
     1 nshtra,ifnig,xmsave(3,3),shif(3),minsh
      common /ord/ x(3,numat),mul(numat),let(numat),
     1 horsum(numat,nset),sum(3,nset),sxy(nset),sxz(nset),syz(nset)
      common /par/ gmin
      common /res/ atom1,atom2,foc,intxt,code,elt
      character sml(27)*1,aa(107)*11,bb(39)*15,csh(17)*14
      character elt(nelts)*2,text*17,ax*47,spgr*10
      character*1 nt(16),code(2),star
      character atom1(numat)*2,atom2(numat)*4,foc(numat)*5
      character cpears*10,cpear(nelts)*7,data*73,intxt*40
      character*8 ca,cb,cc
      character*9 cal,cbe,cga
 
      dimension org(3),nrfile(nset),orsave(3,nset),newnr(nset),
     1 kres(nset),pear(nelts),keq(nset),sm(3),nsp(numat),nchoic(nset)
 
      if(ifmat.eq.1) ax = '-a,-b,-c'
      kfl = 0
      lsave = long
      ig = 0
      kount = 0
      nrres = 1
      do 19 i=1,nset
      sxy(i) = 0.
      sxz(i) = 0.
      syz(i) = 0.
c     sums of all x-coordinates, y-coordinates and z-coordinates :
      do 19 j=1,3
   19 sum(j,i) = 0.
      do 33 i = 1,numat
      do 33 j = 1,nset
   33 horsum(i,j) = 0.
 
      rewind 10
      if(long.le.1) go to 2
      write(nout,25)gmin
      if(isc.eq.1) write(*,25)gmin
   25 format(//' Minimum standardization parameter gamma = ',f8.4)
      if(isc.eq.1) write(*,11)
      write(nout,11)
   11 format(//' All possible settings :')
      if(ipol.eq.0) write(nout,31)
   31 format(' For every setting, origin shifts giving up to 1.0025'/   s
     1' times the minimum gamma have been retained.'//)
 
*     convert values of CODE record into character variables:
    2 call CODREC(ipears,pmin,cpears,nelt,pear,cpear)
 
      continue
c     first reading of unit 10
    1 read(10,end = 10) gamma,text,org
      kount = kount + 1
      if(gmin.gt.0.0001) then
        fac = gamma/gmin
      else
        if(gamma.lt.0.0001) then
          fac = 1.
          else
          fac = gamma
        endif
       endif
c
c     count settings with gamma = gmin
      isum = 0
      if(abs(fac-1.).le.0.00001) then
        isum = 1
        ig = ig + 1
        do 15 i=1,3
   15   orsave(i,ig) = org(i)
        nrfile(ig) = kount
*     initiate kres
        kres(ig) = ig
      endif
c----flag for settings near min. gamma :
      if(fac.gt.1.00001.and.fac.le.1.0025) then
        kfl = kfl + 1
        keq(kfl) = kount
      endif
      if(long.le.1) go to 14
      write(nout,3) text,org,gamma,fac
      if(isc.eq.1)write(*,3) text,org,gamma,fac
 
      if(long.gt.1) write(nout,53) a,b,c,al,be,ga
      if(isc.eq.1) write(*,53) a,b,c,al,be,ga
    3 format(//' Setting ',a17,2x,'origin ',3f8.5,3x,'gamma = ',f8.4/
     1 '  gamma/min.gamma = ',f6.4)
 
   14 do 5 i=1,natom
      read(10,end = 10)nsp(i),(x(j,i),j=1,3),mul(i),let(i),foc(i)
      if(isum.eq.1) then
        do 32 j = 1,3
   32   sum(j,ig) = sum(j,ig) + x(j,i)
c      mixed sums :
        sxy(ig) = sxy(ig)+x(1,i)*x(2,i)
        sxz(ig) = sxz(ig)+x(1,i)*x(3,i)
        syz(ig) = syz(ig)+x(2,i)*x(3,i)
      endif
    5 continue
      if(long.le.1) go to 1
      do 7 i=1,natom
      k = let(i)
      if(isc.eq.1)write(*,8)atom1(i),atom2(i),(x(j,i),j=1,3),foc(i),
     1  mul(i),sml(k)
      write(nout,8)atom1(i),atom2(i),(x(j,i),j=1,3),foc(i),mul(i),
     1  sml(k)
    7 continue
    8 format(' ',a2,1x,a4,3x,3f9.5,5x,a5,5x,i3,a1)
 
      if(isum.eq.1)write(nout,97) (sum(k,ig),k=1,3)
   97 format(/' sums :    ',3f9.5/)
 
      go to 1
   10 if(kount.gt.nset) then
        write(nout,94) kount,nset
        write(*,94) kount,nset
      endif
   94 format(/' WARNING ]]] '/' ',i3,' different settings;',
     1' only ',i3,' will be considered in printing results.')
*     Change value of nset in PARAMETER statement of subroutines
*     CHOICE, ORDER, PRINT, RENUM and RESULT.
 
c     write headings for result
      if(long.gt.0) then
        write(nout,40) intxt
        if(isc.eq.1) write(*,42)
        if(iocfl.eq.1) then
          write(nout,87)
          write(*,87)
   87  format(/' WARNING : occupation factor not = 1 ')
        endif
        if(nfl.eq.1) then
          write(nout,88)
   88   format(/' WARNING : setting -x,-y,-z has NOT been considered',
     1 ' since this would correspond to '/' a space group with ',
     2 'different chirality'/)
        endif
      endif
      if(ifmat.eq.1) then
        if(isc.eq.1.and.long.gt.0) write(*,46)
        write(13,146)
      endif
      if(ifsh.gt.0) then
        write(13,149)
        if(isc.eq.1.and.long.gt.0)write(*,49) sh
      endif
      if(ihex.eq.1) then
        write(13,147)
        if(long.gt.0) then
          if(isc.eq.1)write(*,47)
          if(isc.eq.1) write(*,57) a,a,c
          write(nout,57) a,a,c
        endif
   57 format(' New cell parameters : ',3f8.4,' 90  90  120')
      endif
   46 format(' Transformed from enantiomorphic space group')
  146 format('REMARK Transformed from enantiomorphic space group.')
  147 format('REMARK Transformed from rhombohedral cell.')
   47 format(' Transformation from rhombohedral cell to triple hexagonal
     1 cell')
   48 format(' Extra origin shift, due to interchange of axes : ',a14)
   59 format(' Extra origin shift, due to change of setting : ',a14)
   67 format(' Extra origin shift, due to cell reduction : ',a14)
   49 format(' Extra origin shift of ',3f7.3/' due to transformation',
     1' to setting with centre of symmetry at the origin')
  149 format('REMARK Transformed from non-centrosymmetric setting.')
      star = ' '
      if(ifmat.gt.0.or.ihex.eq.1.or.ifnig.eq.2) then
        if(isc.eq.1.and.long.gt.0) write(*,43) ax
        star = '*'
      endif
      if(pmin.eq.0) then
        if(isc.eq.1)write(*,58) code,ipears,(elt(i),pear(i),i=1,nelt)
      else
       if(isc.eq.1)write(*,70)code,ipears,pmin,(elt(i),pear(i),i=1,nelt)
      endif
      if(nelt.lt.5) then
        do 73 i=nelt+1,5
        elt(i) = ' '
        cpear(i) = ' '
   73   continue
      endif
 
*     prepare cellparameters for file on unit 13 :
      if(ifmat.gt.0.or.ihex.eq.1.or.ifnig.eq.2.and.isc.eq.1.and.
     1 long.eq.0) write(*,43) ax
      call CELOUT(ngr,ca,cb,cc,cal,cbe,cga)
      write(13,153) ca,cb,cc,cal,cbe,cga,star
      if(isc.eq.1) write(*,53) a,b,c,al,be,ga
   53 format(' Cell parameters : ',3f8.4,3f9.3)
  153 format('CELL',9x,3A8,1x,3A9,7x,A1)
      write(13,170) code,cpears,(elt(i),cpear(i),i=1,5)
      if(nelt.gt.5) write(13,171) (elt(i),cpear(i),i=6,nelt)
   58 format(' Pearson code : ',2a1,i4,2x,10(a2,f5.1,2x))
   70 format(' Pearson code : ',2a1,i4,'(-',f6.2,')',2x,10(a2,f5.1,2x))
  170 format('PCODE',2x,2a1,a10,4x,5(a2,1x,a7))
  171 format('PCODE',18x          ,5(a2,1x,a7))
      if(isc.eq.1) write(*,50) spgr,ngr
   50 format(' Space group symbol : ',a10,' Number in IT : ',i3)
      if(ifplus.gt.5) then
        write(nout,209)
        write(*,209)
      endif
  209 format(' subroutine RESULT : error in value of IFPLUS (too many',
     1 ' extra shifts')
      if(ifplus.gt.0.and.ifplus.le.5) then
        go to (201,202,201,204,201) ,ifplus
  201   if(isc.eq.1.and.long.gt.0)write(*,59) csh(nshtra)
        if(ifplus.eq.1) go to 210
        if(ifplus.eq.5) go to 204
  202   if(isc.eq.1.and.long.gt.0)write(*,48) csh(nabc)
        go to 210
  204   if(isc.eq.1.and.long.gt.0) write(*,67) csh(nsh)
  210   continue
      endif
   43 format(/' Axes changed to : ',a47)
   40 format(//'Results for ',a40/)
   42 format(//' Results :')
c
      if(ig.lt.1) then
        if(long.ne.2) then
          write(nout,16)
          write(*,16)
   16   format(/' ERROR : we did not find any structure with min gamma',
     1 '  Go back and print them all')
          long = 2
          rewind 10
          go to 1
        else
          write(nout,17)
          write(*,17)
   17   format(////' Go on with next structure')
        endif
        long = lsave
        return
      endif
c
c     order results, make final choice and print :
      igg = ig
      if(ig.gt.nset) igg = nset
 
c     if several settings with min. gamma, look at vertical sums :
      if(igg.eq.1) then
        nrres = 1
        kres(1) = 1
        newnr(1) = ig
      else
        call CHOICE(natom,1,igg,nrres,kres,newnr)
 
      if(nrres.eq.0) go to 90
      endif
   55 format(/' Setting ',a17,2x,'origin ',3f9.5,3x,'gamma = ',f8.4)
  255 format('gamma',f8.4)
 
      rewind 10
c     reread unit 10 for ordering of settings with min. gamma
 
      kount = 0
      ik = 0
      do 21 ii=1,nrres
      k1 = newnr(ii)
      kk = nrfile(k1)
   23 read(10,end = 30) gamma,text,org
      kount = kount + 1
      do 22 i=1,natom
   22 read(10,end = 30)nsp(i),(x(j,i),j=1,3),mul(i),let(i),foc(i)
      if(kount.eq.kk) then
        if(nrres.eq.1) then
          if(isc.eq.1)write(*,55) text,(orsave(k,k1),k=1,3),gamma
          if(long.gt.1)write(nout,55) text,(orsave(k,k1),k=1,3),gamma
          write(13,255) gamma
        endif
        ik = ik + 1
        call ORDER(natom,nrres,ik,nelt,ax,text,orsave(1,k1),orsave(2,k1)
     1  ,orsave(3,k1),nsp)
*     read unit 13, and rewrite on unit 9 :
        if(nrres.eq.1)   call rewrite
        go to 21
      else
        go to 23
      endif
   21 continue
 
   30 long = lsave
*     if only 1 standardization, the work is done.
      if(nrres.eq.1) go to 160
 
c     look at horizontal sums :
      igg = ik
      call CHOICE(natom,2,igg,nrres,newnr,nchoic)
      if(nrres.eq.0) go to 90
 
      rewind 10
      k = 0
      ik = 0
      do 35 ii=1,nrres
      k1 = nchoic(ii)
      kount = nrfile(k1)
   28 read(10,end=36) gamma,text,org
      k = k + 1
      do 27 i=1,natom
   27 read(10,end = 36)nsp(i),(x(j,i),j=1,3),mul(i),let(i),foc(i)
      if(k.eq.kount) then
        if(ik.GT.0) then
          write(13,163)
          if(isc.eq.1) write(*,63)
        endif
        if(isc.eq.1)write(*,55) text,(orsave(l,k1),l=1,3),gamma
        write(13,255) gamma
        ik = ik + 1
        call ORDER(natom,-ii,ik,nelt,ax,text,orsave(1,k1),orsave(2,k1),
     1    orsave(3,k1),nsp)
*     read unit 13, and rewrite on unit 9 :
        rewind 13
 
 208   read(13,205,end=206) data
 205  format(a73)
 207  format(' ',a73)
        go to 208
 206    call rewrite
      else
        go to 28
      endif
   35 continue
 
   36 long = lsave
 
  160 if(kfl.gt.0) then
        rewind 10
        k = 0
        kk = 0
 
        do 37 i=1,kfl
 
        if(isc.eq.1)write(*,63)
        write(13,163)
   63 format(//' OTHER  standardization with similar gamma :')
  163 format('OTHER  standardization with similar gamma :')
        kount = keq(i)
   39   read(10,end=62) gamma,text,org
        k = k + 1
        do 38 j=1,natom
   38   read(10,end=62)nsp(j),(x(l,j),l=1,3),mul(j),let(j),foc(j)
        if(k.ne.kount) go to 39
        kk = kk + 1
 
c-----compute vertical sums
        do 92 j= 1,3
   92   sm(j) = 0.
        do 93 j= 1,natom
        do 93 l= 1,3
   93   sm(l) = sm(l) + x(l,j)
        if(isc.eq.1)write(*,55) text,org,gamma
        write(13,255) gamma
        call ORDER(natom,1,kk,nelt,ax,text,org(1),org(2),org(3),nsp)
        write(13,97) sm
        call rewrite
 
   37   continue
      endif
   62 return
 
   90 write(nout,91)
   91 format(' ERROR in subroutine CHOICE ')
      long = lsave
      return
 
      end
*COPY REWRITE
      subroutine rewrite
      PARAMETER(numat=150,nset =120,nelts = 8,ndif=30)
      common /eltname/finelt(ndif)
      common /num/nel,newn,nr(ndif),maxnr(ndif)
      common /res/ atom1,atom2,foc,intxt,code,elt
      character  data*73,datas*73,params*15,rems(5)*73,pears*14,sp*17,
     1 def*73,atom1(numat)*2,atom2(numat)*4,foc(numat)*5,intxt*40,
     2 code*2,elt(nelts)*2,ws*38,finelt*2,ch*2,kel(ndif)*2,nums*10
      data nums/'1234567890'/
 
*     look if there atoms which occur only once:
      do 5 i=1,ndif
    5 kel(i) = ' '
      kk= 0
      do 10 i=1,ndif
      if(maxnr(i).le.1) then
        kk = kk + 1
        kel(kk) = finelt(i)
      endif
   10 continue
*     read file 13, write file 9
      ioth = 0
      params = ' '
      datas=' '
      def = ' '
      pears = ' '
      sp = ' '
      ws = ' '
      nrrem = 0
      do 1 i=1,5
    1 rems(i) = ' '
 
      rewind 13
*     read first record (DATA or OTHER), then start loop
      read(13,205,end=210) data
      if(data(1:3).eq.'OTH') ioth = 1
  200 read(13,205,end=210) data
  201 format()
  205 format(a73)
      if(data(1:2).eq.'CG') params(10:15) = data(5:10)
      if(data(1:2).eq.'ga') params(1:7) = data(7:13)
      if(data(1:6).eq.'SPCGRP') then
        datas=data
        sp = data(8:24)
        ws = data(27:64)
      endif
      if(data(1:5).eq.'PCODE') pears=data(8:21)
      if(data(1:6).eq.'REMARK') then
        nrrem = nrrem + 1
        rems(nrrem) = data
      endif
      if(data(1:6).eq.'DEFINE') def =data
      go to 200
 
*     write heading for result:
  210 if(ioth.eq.0) then
        write(9,900) sp,ws,pears
  900 format(/a17,' - ', a38,2x,a14)
  901 format(19x,a9)
  902 format('-------------------------------------------------------',
     1'------------------')
        if(datas(65:73).ne.' ') write(9,901) datas(65:73)
        write(9,902)
      endif
      rewind 13
  215 read(13,205,end=250) data
      if(data(1:4).eq.'DATA'.or.data(1:4).eq.'OTHE') then
         data(59:73) = params
         if(data(1:4).eq.'OTHE') then
           write(9,201)
           write(9,205) data
           write(9,205) datas
         else
           write(9,205) data
         endif
      else if(data(1:5).eq.'PCODE') then
        if(ioth.eq.1) then
          write(9,205) datas
          write(9,205) data
         endif
      else if(data(1:2).eq.'ga'.or.data(1:6).eq.'SPCGRP'.or.
     1 data(1:3).eq.'DEF') then
         go to 215
      else if(data(1:5).eq.'OTHER') then
         go to 250
      else if(data(1:4).eq.'ATOM') then
        if(def.ne.' ') write(9,205) def
        def = ' '
        if(kk.gt.0) then
*     parse data to find atom name:
          jj = 8
          do 20 i=8,13
          if(data(i:i).eq.' ') go to 20
          ch = data(i:i+1)
          jj = i+2
          go to 25
   20     continue
   25     k=index(nums,ch(2:2))
          if(k.gt.0) then
             ch(2:2) = ' '
             jj = i + 1
          endif
          do 30 i=1,kk
          if(ch.ne.kel(i)) go to 30
          kel(i) = ' '
          data(jj:jj+2) = ' '
          go to 40
   30     continue
        endif
   40     write(9,205) data
        go to 215
      else if(data(1:2).eq.'CG') then
        do 220 i=1,nrrem
        if(rems(i).ne.' ') write(9,205) rems(i)
  220   continue
        go to 250
      else
         if(data(1:6).ne.'REMARK') write(9,205) data
      endif
      go to 215
 
  250 rewind 13
      return
      end
*COPY TRAFO
      subroutine TRAFO(ax,text,o1,o2,o3)
*     called by ORDER; writes record TRANS on unit 12
*
      common long,nout,idm,inf,isc,ipol,r
      common /orgin/nor,orgadd(3,8),ntext,icoord
      character chori(9)*3,ax*47,text*17,tratxt(69)*1,ortxt(31)*1,aux*6
      character dum(69)*1
      dimension or(3),ori(9)
 
      data ori/.125,.25,.375,.5,.625,.75,.875,.3333,.6667/
      data chori/'1/8','1/4','3/8','1/2','5/8','3/4','7/8','1/3','2/3'/
 
      aux = ' '
      do 1 i=1,69
      dum(i) = ' '
    1 tratxt(i) = ' '
      do 2 i=1,30
    2 ortxt(i) = ' '
      or(1) = o1
      or(2) = o2
      or(3) = o3
*
*     length ax :
      lax = 47
      if(ax.eq.'abc'.or.ax.eq.'a,b,c') then
        lax = 0
      else
        nbl = 0
        do 10 i=1,47
        if(ax(i:i).ne.' ') go to 10
        nbl = nbl + 1
        if(nbl.eq.2) then
          lax = i-2
          go to 15
        endif
   10   continue
      endif
*
*     length of text :
   15 continue
      lxyz = 17
      if(text.eq.'x,y,z') then
        lxyz = 0
      else
        nbl = 0
        do 20 i=1,17
        if(text(i:i).ne.' ') go to 20
        nbl = nbl + 1
        if(nbl.eq.2) then
          lxyz = i-2
          go to 25
        endif
   20   continue
      endif
 
   25 continue
      i1 = 1
      if(lax.gt.0) then
      do 26 i=1,lax
      tratxt(i1) = ax(i:i)
   26 i1 = i1 + 1
      do 27 i=i1,i1+4
   27   tratxt(i) = ' '
        i1 = i1 + 5
      endif
      if(lxyz.gt.0) then
        do 29 i=1,lxyz
        tratxt(i1) = text(i:i)
   29   i1 = i1 + 1
        do 31 i=i1,i1+4
   31   tratxt(i) = ' '
        i1 = i1 + 5
      endif
      i1 = i1 -1
 
*     origin :
      lori = 1
      if(o1.eq.0..and.o2.eq.0..and.o3.eq.0.) then
        if(lax.eq.0.and.lxyz.eq.0) return
        go to 60
      else
        if(lax.eq.0.and.lxyz.eq.0) then
          ortxt(lori) = 'O'
        else
          ortxt(lori) = 'o'
        endif
        lori = lori + 1
        ortxt(lori) = 'r'
        ortxt(lori+1) = 'i'
        ortxt(lori+2) = 'g'
        ortxt(lori+3) = 'i'
        ortxt(lori+4) = 'n'
        ortxt(lori+5) = ' '
        lori = lori + 6
      endif
 
      do 50 keer = 1,3
      if(icoord.eq.1.and.keer.eq.3) go to 40
      if(icoord.eq.2.and.keer.eq.2) go to 40
      if(icoord.eq.3.and.keer.eq.1) go to 40
      if(icoord.eq.3.and.keer.eq.3) go to 40
      if(icoord.eq.4) go to 40
      if(or(keer).eq.0.) then
        ortxt(lori) = ' '
        ortxt(lori+1) = '0'
        lori = lori + 2
      else
        do 30 i=1,9
        if(abs(or(keer)-ori(i)).le.0.0001) go to 35
   30   continue
        go to 40
   35   ortxt(lori) = ' '
        lori = lori + 1
        do 36 j=1,3
        ortxt(lori) = chori(i)(j:j)
   36   lori = lori + 1
      endif
      go to 50
*     origin not in list; write decimals
   40 ortxt(lori) = ' '
      aux = ' '
      write(aux,'(f6.5)') or(keer)
      do 45 i=1,6
      lori = lori + 1
      ortxt(lori) = aux(i:i)
  45  continue
      lori = lori + 1
   50 continue
 
   60 if(i1.gt.0) then
        write(13,95) (tratxt(j),j=1,i1),(ortxt(k),k=1,lori),
     1  (dum(l),l=1,65-i1-lori)
      else
        write(13,95) (ortxt(k),k=1,lori),(dum(l),l=1,65-lori)
      endif
   95 format('TRANS  ',65a1)
      return
      end
